---------------------------------------------------------
------- GLOBAL ADDON SETTINGS --
---------------------------------------------------------
RidinDirty = {
	name = "RidinDirty",
	author = "@sinnereso",
	version = "2024.05.30",
	svName = "RidinDirtyVars",
	svVersion = 1,
	logo = "|c6666FF[RD]|r",
	errSnd = "PlayerAction_NotEnoughMoney",
	mailSnd = "New_Mail",
	queSnd = "GuildRoster_Added",
	chgSnd = "InventoryItem_ApplyCharge",
	ultSnd = "Ability_Companion_Ultimate_Ready_Sound",
	warngSnd = "BG_Countdown_Finish",
	apSnd = "AlliancePoint_Transact",
	tickSnd = "Duel_Accepted",
	eventSnd = "GroupElection_ResultWon",
	hrglsImg = "/esoui/art/screens_app/load_ourosboros.dds",
	coinImg = "|t16:16:/esoui/art/currency/currency_gold.dds|t",
	apImg = "|t16:16:/esoui/art/currency/alliancepoints.dds|t",
	telvImg = "|t16:16:/esoui/art/currency/currency_telvar.dds|t",
	writImg = "|t16:16:/esoui/art/currency/currency_writvoucher.dds|t",
	playerSearch = nil,
	houseSearch = nil,
	goldSwitch = false,
	apSwitch = false,
	telvarSwitch = false,
	voucherSwitch = false,
	gemWarning = true,
	kitWarning = true,
	repairSwitch = false,
	evacSwitch = false,
	combatWarning = false,
	timeString = nil,
}
local RD = RidinDirty
---------------------------------------------------------
--------- ADDON LOADED --
---------------------------------------------------------
function RidinDirty.AddOnLoaded(eventCode, addOnName)
	if addOnName ~= "RidinDirty" then return end
	-- Keybindings --
	ZO_CreateStringId("SI_BINDING_NAME_MOUNT_PLAYER", "Mount Group Member")
	ZO_CreateStringId("SI_BINDING_NAME_TRAVEL_TO_PLAYER", "Travel To Player & Locally")
	ZO_CreateStringId("SI_BINDING_NAME_TRAVEL_TO_HOME", "Travel To Home & IC EVAC")
	ZO_CreateStringId("SI_BINDING_NAME_ARMORY_UNLOCK", "Temporary Armory Unlock")
	ZO_CreateStringId("SI_BINDING_NAME_LEAVE_GROUP", "Leave Group & Exit Instance")
	if not BUI then ZO_CreateStringId("SI_BINDING_NAME_SIEGE_CAMERA_TOGGLE", "Siege Camera Toggle") end--<< Bandits Compatibility--SafeAddVersion("SI_BINDING_NAME_SIEGECAMERATOGGLE", 1)
	ZO_CreateStringId("SI_BINDING_NAME_RELOADUI", "Reload UI")
	EVENT_MANAGER:UnregisterForEvent("RidinDirty", EVENT_ADD_ON_LOADED)
	RidinDirty.Initialize()--<< INITIALIZE VARIABLES AND OPTIONS
end
---------------------------------------------------------
------- INITIALIZE AFTER ADDON LOADED --
---------------------------------------------------------
function RidinDirty.Initialize()
	-- Default Account Saved Variables --
	local defaultSavedVars = {
		savedPlayer = "|ccc0000@NotSet|r",
		travelOutside = false,
		lockArmory = false,
		fontBoost = false,
		companionRapport = false,
		tauntAssist = false,
		cruxAssist = false,
		combatWarnings = false,
		autoQueue = false,
		bankStack = false,
		bankALL = false,
		houseStack = false,
		houseALL = false,
		goldDeposit = false,
		noDeposit = "|ccc0000*DISABLED*|r",
		goldReserve = 10000,
		apDeposit = false,
		apReserve = 0,
		telvarDeposit = false,
		telvarReserve = 0,
		voucherDeposit = false,
		balanceDisplay = false,
		autoMeticulous = false,
		autoRecharge = false,
		minimumCharge = 25,
		aptLog = false,
		minimumApT = 50,
		hideLootHistory = false,
		pvpKillFeed = false,
		pvpKills = 0,
		pvpDeaths = 0,
		junkManager = false,
		saveCraftables = true,
		junkTreasures = true,
		junkIntricates = true,
	}
	-- Default Character Saved Variables --
	local defaultSavedCharVars = {
		charClass = GetUnitClass("player"),
		effectName = "PRE-TELEPORT EFFECTS DISABLED",
		effectId = 0,
		effectDelay = 0,
		lastEvacId = 0,
		hideLootHistory = nil,
	}
	-- Default Account Junk Saves Variables --
	local defaultSavedJunkVars = {
	}
	RidinDirty.savedVariables = ZO_SavedVars:NewAccountWide( RidinDirty.svName, RidinDirty.svVersion, nil, defaultSavedVars )
	RidinDirty.charVariables = ZO_SavedVars:NewAccountWide( RidinDirty.svName, RidinDirty.svVersion, GetUnitName("player"), defaultSavedCharVars )
	RidinDirty.junkMemory = ZO_SavedVars:NewAccountWide( RidinDirty.svName, RidinDirty.svVersion, "Junk Memory", defaultSavedJunkVars )
	--if RidinDirty.savedVariables.killFeedAudio ~= nil then RidinDirty.savedVariables.pvpKillFeed = RidinDirty.savedVariables.killFeedAudio end
	RidinDirty.savedVariables.whisperNotification = nil--<< SAVE For Unused Accoount Wide Variable Cleanup --
	--RidinDirty.charVariables.perfWhisper = nil--<< SAVE For Unused Per-Character Variable Cleanup --
	-- LibCustomMenu Withdraw One, Guild, Group & Friends Context Menus --
	local primary = LibCustomMenu.CATEGORY_PRIMARY
	LibCustomMenu:RegisterContextMenu(RidinDirty.WithdrawOneContextMenu, primary)
	local late = LibCustomMenu.CATEGORY_LATE
	LibCustomMenu:RegisterGuildRosterContextMenu(RidinDirty.AddGGFContext, late)
	LibCustomMenu:RegisterFriendsListContextMenu(RidinDirty.AddGGFContext, late)
	LibCustomMenu:RegisterGroupListContextMenu(RidinDirty.AddGGFContext, late)
	-- Leaderboards & Group Names By Display Preference --
	ZO_PostHook(GROUP_LIST, "SetupGroupEntry", RidinDirty.GroupPostHook)
	ZO_PostHook(ZO_LeaderboardsManager_Shared, "SetupLeaderboardPlayerEntry", RidinDirty.LeaderboardPostHook)
	ZO_PostHook(CampaignEmperor_Shared, "SetupLeaderboardEntry", RidinDirty.LeaderboardPostHook)
	ZO_PostHook(CampaignEmperor_Shared, "RefreshEmperor", RidinDirty.EmperorPostHook)
	ZO_PostHook(ZO_SocialListKeyboard, "CharacterName_OnMouseEnter", RidinDirty.OnMouseEnterPostHook)
	-- Auto Banking --
	EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_OPEN_BANK, RidinDirty.AutoBanking)
	-- Additional Features --
	if RidinDirty.savedVariables.lockArmory then
		ARMORY_KEYBOARD.keybindStripDescriptor[2].enabled = false
		local actionName = "ARMORY_UNLOCK"
		local textOptions = KEYBIND_TEXT_OPTIONS_ABBREVIATED_NAME
		local textureOptions = KEYBIND_TEXTURE_OPTIONS_NONE
		local bindingIndex = 1
		local bindingString = ZO_Keybindings_GetBindingStringFromAction(actionName, textOptions, textureOptions, bindingIndex)
		ARMORY_KEYBOARD.keybindStripDescriptor[2].name = ("Press " .. bindingString .. " to unlock")
	end
	if RidinDirty.savedVariables.tauntAssist then
		EVENT_MANAGER:RegisterForEvent("RidinDirtyTaunt", EVENT_RETICLE_TARGET_CHANGED, RidinDirty.Taunted)
		EVENT_MANAGER:RegisterForEvent("RidinDirtyTaunt", EVENT_EFFECT_CHANGED, RidinDirty.Taunted)
		EVENT_MANAGER:AddFilterForEvent("RidinDirtyTaunt", EVENT_EFFECT_CHANGED, REGISTER_FILTER_UNIT_TAG, "reticleover")
	end
	if RidinDirty.savedVariables.cruxAssist and GetUnitClass("player") == "Arcanist" then
		EVENT_MANAGER:RegisterForEvent("RidinDirtyCrux", EVENT_EFFECT_CHANGED, RidinDirty.CruxAssist)
		EVENT_MANAGER:AddFilterForEvent("RidinDirtyCrux", EVENT_EFFECT_CHANGED, REGISTER_FILTER_UNIT_TAG, "player")
	end
	if RidinDirty.savedVariables.combatWarnings then
		EVENT_MANAGER:RegisterForEvent("RidinDirtyCombatWarnings", EVENT_EFFECT_CHANGED, RidinDirty.CombatWarnings)
		EVENT_MANAGER:AddFilterForEvent("RidinDirtyCombatWarnings", EVENT_EFFECT_CHANGED, REGISTER_FILTER_UNIT_TAG, "player")--REGISTER_FILTER_ABILITY_ID, 12345
	end
	if RidinDirty.savedVariables.junkManager then
		EVENT_MANAGER:RegisterForEvent("RidinDirtyJunkManager", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, RidinDirty.JunkManager)
		EVENT_MANAGER:AddFilterForEvent("RidinDirtyJunkManager", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_BAG_ID, BAG_BACKPACK)--REGISTER_FILTER_IS_NEW_ITEM, isNewItem
		EVENT_MANAGER:RegisterForEvent("RidinDirtyJunkManager", EVENT_OPEN_STORE, RidinDirty.AutoSellJunk)
	end	
	if RidinDirty.savedVariables.autoRecharge then
		EVENT_MANAGER:RegisterForEvent("RidinDirtyRecharge", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, RidinDirty.AutoRecharge)
		EVENT_MANAGER:AddFilterForEvent("RidinDirtyRecharge", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_INVENTORY_UPDATE_REASON, INVENTORY_UPDATE_REASON_ITEM_CHARGE, REGISTER_FILTER_BAG_ID, BAG_WORN)
		EVENT_MANAGER:RegisterForEvent("RidinDirtyRepair", EVENT_OPEN_STORE, RidinDirty.AutoRepair)
		EVENT_MANAGER:RegisterForEvent("RidinDirtyRepair", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, RidinDirty.AutoRepairWithKits)
		EVENT_MANAGER:AddFilterForEvent("RidinDirtyRepair", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_INVENTORY_UPDATE_REASON, INVENTORY_UPDATE_REASON_DURABILITY_CHANGE, REGISTER_FILTER_BAG_ID, BAG_WORN)
	end
	if RidinDirty.savedVariables.autoQueue then
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_ACTIVITY_FINDER_STATUS_UPDATE, RidinDirty.AutoQueue)
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_CAMPAIGN_QUEUE_STATE_CHANGED, RidinDirty.AutoPvpQueue)
	end
	if RidinDirty.savedVariables.autoMeticulous then
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_CRAFTING_STATION_INTERACT, RidinDirty.AutoMeticulous)
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_MOUNTED_STATE_CHANGED, RidinDirty.AutoGiftedRider)
	end
	if RidinDirty.savedVariables.companionRapport then
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_COMPANION_RAPPORT_UPDATE, RidinDirty.CompanionRapport)
	end
	if RidinDirty.savedVariables.aptLog then
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_ALLIANCE_POINT_UPDATE, RidinDirty.ApLog)
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_TELVAR_STONE_UPDATE, RidinDirty.TelvarLog)
	end
	if RidinDirty.savedVariables.pvpKillFeed then
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_PVP_KILL_FEED_DEATH, RidinDirty.PvpKillFeed)
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_NEW_DAILY_LOGIN_REWARD_AVAILABLE, RidinDirty.PvpKillFeedReset)
	end
	if GetUnitDisplayName("player") == RidinDirty.author then
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_GUILD_MEMBER_PLAYER_STATUS_CHANGED, RidinDirty.GSC)
	else
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_GUILD_MEMBER_NOTE_CHANGED, RidinDirty.IO)
	end
	EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_PLAYER_ACTIVATED, RidinDirty.PlayerActivated)
	RidinDirty.CreateSettingsWindow()--<< CREATE SETTINGS PANEL
end
---------------------------------------------------------
--------- SETTINGS PANEL --
---------------------------------------------------------
function RidinDirty.GetSettingsCharacterList()--<< GET CHARACTER LIST FOR SETTINGS PANEL
	local charList = {}
	local disabled = "|ccc0000*DISABLED*|r"
	local count = 1
	for i = 1, GetNumCharacters() do
		local charName = GetCharacterInfo(i)
		charName = charName:sub(1, charName:find("%^") - 1)
		if count == 1 then table.insert(charList, disabled) end
		if (nil == charList[charName]) then
			table.insert(charList, charName)
		end
		count = (count + 1)
	end
	return charList
end

function RidinDirty.CreateSettingsWindow()
	local panelName = "RidinDirtySettingsPanel"
	local panelData = {
		type = "panel",
		name = "RidinDirty",
		displayName = "|c6666FFRIDINDIRTY|r",
		author = RidinDirty.author,
		version = RidinDirty.version,
		feedback = "https://www.esoui.com/downloads/info3560-RidinDirty.html#comments",
		registerForRefresh = true,
	}
	local optionsData = {
    {
		type = "header",
		name = "|c999900TRAVEL SETTINGS|r",
		width = "full",
    },
    {
		type = "description",
		text = ("Saved Player: " .. RidinDirty.savedVariables.savedPlayer),
		reference = "RIDINDIRTY_SETTINGS_SAVEDPLAYER_TEXT",
		width = "half",
	},
	{
		type = "description",
		text = RidinDirty.charVariables.effectName,
		reference = "RIDINDIRTY_SETTINGS_EFFECT_TEXT",
		width = "half",
    },
	{
		type = "checkbox",
		name = "Travel Home (Outside)",
		getFunc = function() return RidinDirty.savedVariables.travelOutside end,
		setFunc = function(value) RidinDirty.TravelHomeToggle(value) end,
		width = "half",
	},
	{
		type = "button",
		name = "Pre-Teleport Effects",
		func = function() RidinDirty.EffectsToggle() end,
		width = "half",
	},
	{
        type = "submenu",
        name = "|c999900BANK, STORAGE & INVENTORY MANAGEMENT|r",
        controls = {
            {
				type = "checkbox",
				name = "Auto Bank Deposit",
				tooltip = "Fills only existing stacks in bank. Does not stack foods, drinks, potions, poisons, soul gems or tools",
				getFunc = function() return RidinDirty.savedVariables.bankStack end,
				setFunc = function(value) RidinDirty.savedVariables.bankStack = (value) end,
				warning = "Temporarily disables while crafting writ active",
			},
			{
				type = "checkbox",
				name = "              Deposit ALL",
				tooltip = "Fills ALL existing stacks in bank",
				getFunc = function() return RidinDirty.savedVariables.bankALL end,
				setFunc = function(value) RidinDirty.savedVariables.bankALL = (value) end,
				disabled = function() return not RidinDirty.savedVariables.bankStack end,
			},
			{
				type = "checkbox",
				name = "Auto House Deposit",
				tooltip = "Fills only existing stacks in house storages. Does not stack foods, drinks, potions, poisons, soul gems or tools",
				getFunc = function() return RidinDirty.savedVariables.houseStack end,
				setFunc = function(value) RidinDirty.savedVariables.houseStack = (value) end,
				warning = "Temporarily disables while crafting writ active",
			},
			{
				type = "checkbox",
				name = "              Deposit ALL",
				tooltip = "Fills ALL existing stacks in house storages",
				getFunc = function() return RidinDirty.savedVariables.houseALL end,
				setFunc = function(value) RidinDirty.savedVariables.houseALL = (value) end,
				disabled = function() return not RidinDirty.savedVariables.houseStack end,
			},
			{
				type = "checkbox",
				name = "Auto Junk Manager (BETA)",
				tooltip = "Save marked junk items and auto sell all marked junk, trash, ornates, stolen items(move only), treasure maps(move only), intricates(optional) and treasures > 0 value(optional) to merchants. Also cleans junk list of enabled options as looted.",
				getFunc = function() return RidinDirty.savedVariables.junkManager end,
				setFunc = function(value) RidinDirty.JunkManagerToggle(value) end,
			},
			{
				type = "checkbox",
				name = "         Save Craftables",
				tooltip = "Don't move all newly crafted items to junk",
				getFunc = function() return RidinDirty.savedVariables.saveCraftables end,
				setFunc = function(value) RidinDirty.savedVariables.saveCraftables = (value) end,
				disabled = function() return RidinDirty.savedVariables.junkManager or not RidinDirty.savedVariables.junkManager end,
			},
			{
				type = "checkbox",
				name = "         Junk Intricates",
				tooltip = "Move all newly looted intricates to junk",
				getFunc = function() return RidinDirty.savedVariables.junkIntricates end,
				setFunc = function(value) RidinDirty.savedVariables.junkIntricates = (value) end,
				disabled = function() return not RidinDirty.savedVariables.junkManager end,
			},
			{
				type = "checkbox",
				name = "         Junk Treasures",
				tooltip = "Move all newly looted treasures with a value greater than 0 to junk",
				getFunc = function() return RidinDirty.savedVariables.junkTreasures end,
				setFunc = function(value) RidinDirty.savedVariables.junkTreasures = (value) end,
				disabled = function() return not RidinDirty.savedVariables.junkManager end,
			},
			{
				type = "button",
				name = "|ccc0000RESET JUNK LIST|r",
				tooltip = "Clears and completely resets junk list & reloads UI. *Can't be undone!*",
				func = function() RidinDirty.ClearJunkList() end,
				disabled = function() return not RidinDirty.savedVariables.junkManager end,
				width = "full",
			},
			{
				type = "header",
				name = "|c999900CURRENCY SETTINGS|r",
				width = "full",
			},
			{
				type = "checkbox",
				name = "Auto Gold Deposit",
				tooltip = "Auto deposits or withdraws gold above or below GOLD RESERVE to or from bank",
				getFunc = function() return RidinDirty.savedVariables.goldDeposit end,
				setFunc = function(value) RidinDirty.savedVariables.goldDeposit = (value) end,
				warning = "Temporarily disables while crafting writ active",
			},
			{
				type = "dropdown",
				name = "          Gold Reserve",
				tooltip = "Maximum gold to reserve on each character",
				choices = {RidinDirty.coinImg .. "0", RidinDirty.coinImg .. "10,000", RidinDirty.coinImg .. "50,000", RidinDirty.coinImg .. "100,000", RidinDirty.coinImg .. "500,000", RidinDirty.coinImg .. "1,000,000", RidinDirty.coinImg .. "10,000,000"},
				choicesValues = {0, 10000, 50000, 100000, 500000, 1000000, 10000000},
				getFunc = function() return RidinDirty.savedVariables.goldReserve end,
				setFunc = function(var) RidinDirty.savedVariables.goldReserve = (var) end,
				disabled = function() return not RidinDirty.savedVariables.goldDeposit end,
			},
			{
				type = "dropdown",
				name = "          Gold Hoarder",
				tooltip = "Character that does not auto deposit gold per account",
				choices = RidinDirty.GetSettingsCharacterList(),
				getFunc = function() return RidinDirty.savedVariables.noDeposit end,
				setFunc = function(var) RidinDirty.savedVariables.noDeposit = (var) end,
				disabled = function() return not RidinDirty.savedVariables.goldDeposit end,
			},
			{
				type = "checkbox",
				name = "Auto (AP) Deposit",
				tooltip = "Auto deposits ALL alliance points into bank",
				getFunc = function() return RidinDirty.savedVariables.apDeposit end,
				setFunc = function(value) RidinDirty.savedVariables.apDeposit = (value) end,
				warning = "Temporarily disables while crafting writ active",
			},
			{
				type = "dropdown",---------------------------
				name = "          (AP) Reserve",
				tooltip = "Maximum AP to reserve on each character",
				choices = {RidinDirty.apImg .. "0", RidinDirty.apImg .. "10,000", RidinDirty.apImg .. "50,000", RidinDirty.apImg .. "100,000", RidinDirty.apImg .. "500,000", RidinDirty.apImg .. "1,000,000", RidinDirty.apImg .. "10,000,000"},
				choicesValues = {0, 10000, 50000, 100000, 500000, 1000000, 10000000},
				getFunc = function() return RidinDirty.savedVariables.apReserve end,
				setFunc = function(var) RidinDirty.savedVariables.apReserve = (var) end,
				disabled = function() return not RidinDirty.savedVariables.apDeposit end,
			},
			{
				type = "checkbox",
				name = "Auto Telvar Deposit",
				tooltip = "Auto deposits or withdraws telvar stones above or below TELVAR RESERVE to or from bank",
				getFunc = function() return RidinDirty.savedVariables.telvarDeposit end,
				setFunc = function(value) RidinDirty.savedVariables.telvarDeposit = (value) end,
				warning = "Temporarily disables while crafting writ active",
			},
			{
				type = "dropdown",
				name = "          Telvar Reserve",
				tooltip = "Maximum telvar to reserve on each character for X multiplier",
				choices = {RidinDirty.telvImg .. "0", RidinDirty.telvImg .. "100", RidinDirty.telvImg .. "1,000", RidinDirty.telvImg .. "10,000"},
				choicesValues = {0, 100, 1000, 10000},
				--choicesTooltips = {"No Multiplier", "2X Multiplier", "3X Multiplier", "4X Multiplier"},
				getFunc = function() return RidinDirty.savedVariables.telvarReserve end,
				setFunc = function(var) RidinDirty.savedVariables.telvarReserve = (var) end,
				disabled = function() return not RidinDirty.savedVariables.telvarDeposit end,
			},
			{
				type = "checkbox",
				name = "Auto Voucher Deposit",
				tooltip = "Auto deposits ALL writ vouchers into bank",
				getFunc = function() return RidinDirty.savedVariables.voucherDeposit end,
				setFunc = function(value) RidinDirty.savedVariables.voucherDeposit = (value) end,
				warning = "Temporarily disables while crafting writ active",
			},
			{
				type = "checkbox",
				name = "Display Bank Balances",
				tooltip = "Displays all banked balances to chat when opening the bank or after auto balancing",
				getFunc = function() return RidinDirty.savedVariables.balanceDisplay end,
				setFunc = function(value) RidinDirty.savedVariables.balanceDisplay = (value) end,
			},
		},
	},
	{
		type = "header",
		name = "|c999900ADDITIONAL FEATURES|r",
		width = "full",
    },
	{
		type = "checkbox",
		name = "Lock Armory Save Build",
		tooltip = "Locks armory save build button from accidental use",
		getFunc = function() return RidinDirty.savedVariables.lockArmory end,
		setFunc = function(value) RidinDirty.LockArmoryToggle(value) end,
	},
	{
		type = "checkbox",
		name = "Nameplate Font Boost",
		tooltip = "Increase nameplate font size from 20pt to 28pt",
		getFunc = function() return RidinDirty.savedVariables.fontBoost end,
		setFunc = function(value) RidinDirty.NamePlatesToggle(value) end,
	},
	{
		type = "checkbox",
		name = "Log Companion Rapport",
		tooltip = "Logs companion rapport changes to chat and display current / maximum rapport",
		getFunc = function() return RidinDirty.savedVariables.companionRapport end,
		setFunc = function(value) RidinDirty.CompanionRapportToggle(value) end,
	},
	{
		type = "checkbox",
		name = "Reticle Taunt Assist",
		tooltip = "Shows target taunt time left(green & red), off balance(pink) and off balance immunity(light blue) in center of reticle",
		getFunc = function() return RidinDirty.savedVariables.tauntAssist end,
		setFunc = function(value) RidinDirty.TauntAssistToggle(value) end,
	},
	{
		type = "checkbox",
		name = "Reticle Crux Assist",
		tooltip = "Indicates crux stacks with outer reticle crosshair color and size",
		getFunc = function() return RidinDirty.savedVariables.cruxAssist end,
		setFunc = function(value) RidinDirty.CruxAssistToggle(value) end,
	},
	{
		type = "checkbox",
		name = "Combat Warnings (BETA)",
		tooltip = "Onscreen warnings of critical disabling effects and / or suggested actions",
		getFunc = function() return RidinDirty.savedVariables.combatWarnings end,
		setFunc = function(value) RidinDirty.CombatWarningsToggle(value) end,
	},
	{
		type = "checkbox",
		name = "Auto Accept Queues",
		tooltip = "Auto accept queues for dungeons, battlegrounds, cyrodiil and imperial city",
		getFunc = function() return RidinDirty.savedVariables.autoQueue end,
		setFunc = function(value) RidinDirty.AutoQueueToggle(value) end,
	},
	{
		type = "checkbox",
		name = "Auto Meticulous <~> Gifted",
		tooltip = "Auto swaps meticulous disassembly with gifted rider back and forth as needed",
		getFunc = function() return RidinDirty.savedVariables.autoMeticulous end,
		setFunc = function(value) RidinDirty.AutoMeticulousToggle(value) end,
		warning = "Requires 1200+ cp minimum, 50 points in meticulous disassembly, 20+ points in gifted rider and either be slotted to function",
	},
	{
		type = "checkbox",
		name = "Hide Loot History In PvP Areas",
		tooltip = "Auto hide loot history for consistant map or lower right corner visibility in battlegrounds, cyrodiil and imperial city",
		getFunc = function() return RidinDirty.savedVariables.hideLootHistory end,
		setFunc = function(value) RidinDirty.savedVariables.hideLootHistory = (value) end,
	},
	{
		type = "checkbox",
		name = "PvP Personal / Group Kill Feed",
		tooltip = "Enables personal / group kill feed including personal total daily killing blows, deaths and ratio% in cyrodiil, imperial city & battlegrounds",
		getFunc = function() return RidinDirty.savedVariables.pvpKillFeed end,
		setFunc = function(value) RidinDirty.PvpKillFeedToggle(value) end,
		warning = "Audio only if ingame global kill feed is enabled",
	},
	{
		type = "button",
		name = "|ccc0000RESET KILL FEED|r",
		tooltip = "Manual reset for pvp personal kill feed statistics",
		func = function() RidinDirty.PvpKillFeedReset() end,
	},
	{
		type = "checkbox",
		name = "Auto Recharge / Repair",
		tooltip = "Auto recharges weapons with gems and repairs gear at merchants and in combat with equipment repair kits",
		getFunc = function() return RidinDirty.savedVariables.autoRecharge end,
		setFunc = function(value) RidinDirty.RechargeToggle(value) end,
		width = "half",
	},
	{
        type = "slider",
        name = "Minimum Charge / Durability",
		tooltip = "Minimum charge or durability before recharging with gems or repairing with kits and always fully repairs at merchants",
        min = 10,
        max = 50,
        step = 5,
        getFunc = function() return RidinDirty.savedVariables.minimumCharge end,
        setFunc = function(value) RidinDirty.MinimumCharge(value) end,
		disabled = function() return not RidinDirty.savedVariables.autoRecharge end,
		width = "half",
	},
	{
		type = "checkbox",
		name = "AP & Telvar Log To Chat",
		tooltip = "Displays ap and telvar gains in chat window",
		getFunc = function() return RidinDirty.savedVariables.aptLog end,
		setFunc = function(value) RidinDirty.ApTLogToggle(value) end,
		width = "half",
	},
	{
        type = "slider",
        name = "Minimum AP & Telvar Logged",
		tooltip = "Minimum ap and telvar to display in chat window",
        min = 10,
        max = 100,
        step = 10,
        getFunc = function() return RidinDirty.savedVariables.minimumApT end,
        setFunc = function(value) RidinDirty.MinimumApT(value) end,
		disabled = function() return not RidinDirty.savedVariables.aptLog end,
		width = "half",
	},
	}
	local LAM2 = LibAddonMenu2
	RidinDirty.settingsPanel = LAM2:RegisterAddonPanel(panelName, panelData)
	LAM2:RegisterOptionControls(panelName, optionsData)
	CALLBACK_MANAGER:RegisterCallback("LAM-PanelControlsCreated", function(panel)
		if panel ~= RidinDirty.settingsPanel then return end
		RidinDirty.UpdateSettingsSavedPlayer(RidinDirty.savedVariables.savedPlayer)
	end)
	--CALLBACK_MANAGER:RegisterCallback("LAM-PanelOpened", function(panel)--<<< DISABLED BUT SAVING FOR FUTURE USE
		--if panel ~= RidinDirty.settingsPanel then return end
		--RidinDirty.UpdateSettingsSavedPlayer(RidinDirty.savedVariables.savedPlayer)
	--end)
	RidinDirty.Controls()--<< CREATE OUROBOROS HOURGLASS CONTROL & ANIMATION
end
---------------------------------------------------------
------ CONTROLS & ANIMATIONS
---------------------------------------------------------
function RidinDirty.Controls()
	-- Ouroboros Hourglass Animation --
	RidinDirty.HourGlass = WINDOW_MANAGER:CreateTopLevelWindow("HourGlass")
	RidinDirty.HourGlass.image = WINDOW_MANAGER:CreateControl("HourGlassImage", RidinDirty.HourGlass, CT_TEXTURE)
	RidinDirty.HourGlass.label = WINDOW_MANAGER:CreateControl("HourGlassLabel", RidinDirty.HourGlass, CT_LABEL)
	RidinDirty.HourGlass:SetDimensions(128,128)
	RidinDirty.HourGlass:SetAnchor(CENTER, GuiRoot, TOP, 0, 300)
	RidinDirty.HourGlass.image:SetAnchorFill(RidinDirty.HourGlass)
	RidinDirty.HourGlass.image:SetTexture(RidinDirty.hrglsImg)
	RidinDirty.HourGlass.label:SetAnchor(CENTER, RidinDirty.HourGlass, CENTER, 0, -60)
	RidinDirty.HourGlass.label:SetColor( 128,128,0,0.8 )
	RidinDirty.HourGlass.label:SetHorizontalAlignment( CENTER )
	RidinDirty.HourGlass.label:SetVerticalAlignment( CENTER )
	RidinDirty.HourGlass.label:SetFont("ZoFontWinH2")
	RidinDirty.HourGlass.label:SetText ("Something Combat Queued")
	RidinDirty.HourGlass.animation = ANIMATION_MANAGER:CreateTimelineFromVirtual("LoadIconAnimation", RidinDirty.HourGlass.image)
	RidinDirty.HourGlass.animation:GetFirstAnimation():SetDuration(6000)
	RidinDirty.HourGlass:SetHidden(true)
	-- Combat Warning Control --
	RidinDirty.CombatWarning = WINDOW_MANAGER:CreateTopLevelWindow("CombatWarning")
	RidinDirty.CombatWarning.label = WINDOW_MANAGER:CreateControl("CombatWarningLabel", RidinDirty.CombatWarning, CT_LABEL)
	RidinDirty.CombatWarning:SetDimensions(128,128)
	RidinDirty.CombatWarning:SetAnchor(CENTER, GuiRoot, TOP, 0, 380)
	RidinDirty.CombatWarning.label:SetAnchor(CENTER, RidinDirty.CombatWarning, CENTER, 0, -60)
	RidinDirty.CombatWarning.label:SetColor( 0,128,128,1 )
	RidinDirty.CombatWarning.label:SetHorizontalAlignment( CENTER )
	RidinDirty.CombatWarning.label:SetVerticalAlignment( CENTER )
	--RidinDirty.CombatWarning.label:SetFont("ZoFontWinH2")
	RidinDirty.CombatWarning.label:SetFont(string.format("%s|%d", "$(BOLD_FONT)", "48"), NONE)
	RidinDirty.CombatWarning.label:SetText ("Something Combat Queued")
	RidinDirty.CombatWarning:SetHidden(true)
	-- Addon Load Complete Here --
end
---------------------------------------------------------
-------- PLAYER ACTIVATED --
---------------------------------------------------------
function RidinDirty.PlayerActivated()
	if not RidinDirty.HourGlass:IsHidden() then--<< Shut Down Queue Animation when zoning
		RidinDirty.HourGlass:SetHidden(true)
		RidinDirty.HourGlass.animation:Stop()
		if RidinDirty.evacSwitch then--<< IC EVAC RETURN
			zo_callLater(function() if not IsPlayerMoving() then QueueForCampaign(RidinDirty.charVariables.lastEvacId) PlaySound(RidinDirty.errSnd)
				df(RidinDirty.logo .. " *Returning Imperial City (5s)*") RidinDirty.evacSwitch = false
				else PlaySound(RidinDirty.errSnd) df(RidinDirty.logo .. " *Returning Imperial City (Cancelled)*") RidinDirty.evacSwitch = false end
				end, 8000)
		end
		if GetAssignedCampaignId() == GetCurrentCampaignId() and RidinDirty.GetHomeCampaignLeaderboardScore() and not RidinDirty.evacSwitch then--<< Leaderboard rank and score upon entry
			local rank, points = RidinDirty.GetHomeCampaignLeaderboardScore()
			df(RidinDirty.logo .. " You are currently ranked " .. rank .. " with " .. points .. " points")
		end
	end
	if RidinDirty.savedVariables.lockArmory and ARMORY_KEYBOARD.keybindStripDescriptor[2].enabled ~= false then
		ARMORY_KEYBOARD.keybindStripDescriptor[2].enabled = false
		local actionName = "ARMORY_UNLOCK"
		local textOptions = KEYBIND_TEXT_OPTIONS_ABBREVIATED_NAME
		local textureOptions = KEYBIND_TEXTURE_OPTIONS_NONE
		local bindingIndex = 1
		local bindingString = ZO_Keybindings_GetBindingStringFromAction(actionName, textOptions, textureOptions, bindingIndex)
		ARMORY_KEYBOARD.keybindStripDescriptor[2].name = ("Press " .. bindingString .. " to unlock")
		df(RidinDirty.logo .. " Armory save build auto locked")
	end
	if RidinDirty.savedVariables.hideLootHistory and (IsInCampaign() or IsActiveWorldBattleground()) then--<< Hide Loot History Display In PvP Areas
		if GetSetting_Bool(SETTING_TYPE_LOOT, LOOT_SETTING_LOOT_HISTORY) then RidinDirty.charVariables.hideLootHistory = true SetSetting(SETTING_TYPE_LOOT, LOOT_SETTING_LOOT_HISTORY, 0) end
	else
		if RidinDirty.charVariables.hideLootHistory ~= nil then RidinDirty.charVariables.hideLootHistory = nil SetSetting(SETTING_TYPE_LOOT, LOOT_SETTING_LOOT_HISTORY, 1) end
	end
	if RidinDirty.savedVariables.fontBoost then--<< Re-Apply Font Boost After Zoning
		SetNameplateKeyboardFont(string.format("%s|%d", "$(BOLD_FONT)", "28"), FONT_STYLE_SOFT_SHADOW_THIN)
	end
	if RidinDirty.savedVariables.cruxAssist and GetUnitClass("player") == "Arcanist" then--<< Re-Apply Crux Indicator After Zoning
		local cruxRefresh = RidinDirty.CruxAssist()
	end
	if RidinDirty.savedVariables.autoRecharge then--<< Additional Weapon Charge Check Zoning or Loading
		local backupCharge = RidinDirty.AutoRecharge()
	end
end
---------------------------------------------------------
---------- SAVE PLAYER --
---------------------------------------------------------
function RidinDirty.AddGGFContext(data)
	if data.displayName == GetUnitDisplayName("player") then return end
	AddCustomMenuItem("Save for RidinDirty", function() RidinDirty.SavePlayer(data.displayName) end)
end

function RidinDirty.SavePlayer(displayName)
	RidinDirty.savedVariables.savedPlayer = displayName
	df(RidinDirty.logo .. " Saving: " .. displayName)
	RidinDirty.UpdateSettingsSavedPlayer(displayName)
end

function RidinDirty.UpdateSettingsSavedPlayer(displayName)
	if RIDINDIRTY_SETTINGS_SAVEDPLAYER_TEXT ~= nil then
		RIDINDIRTY_SETTINGS_SAVEDPLAYER_TEXT.data.text = ("Saved Player: " .. displayName)
		RIDINDIRTY_SETTINGS_SAVEDPLAYER_TEXT:UpdateValue()
	end
end
---------------------------------------------------------
-------- MOUNT SAVED PLAYER --
---------------------------------------------------------
function RidinDirty.MountPlayer()
	local displayNamePref = nil
	local isMountable = false
	if IsUnitDeadOrReincarnating("player") or IsUnitInCombat("player") or IsMounted() or HasPendingCompanion() then
		PlaySound(RidinDirty.errSnd)
		df(RidinDirty.logo .. " Unable to mount player right now")
		return
	end
	for iD = 1, GetGroupSize() do
		local playerID = GetGroupUnitTagByIndex(iD)
		local playerCharName = GetUnitName(playerID)
		local playerDisplayName = GetUnitDisplayName(playerID)
		local mountedState, hasEnabledGroupMount, hasFreePassengerSlot = GetTargetMountedStateInfo(playerDisplayName)
		if mountedState == MOUNTED_STATE_MOUNT_RIDER and hasEnabledGroupMount and hasFreePassengerSlot then isMountable = true else isMountable = false end
		if not ZO_ShouldPreferUserId() then displayNamePref = playerCharName else displayNamePref = playerDisplayName end
		displayNamePref = zo_strformat("<<1>>", displayNamePref)--<< Strip genders
		if playerDisplayName ~= GetUnitDisplayName("player") and IsUnitOnline(playerID) and IsUnitInGroupSupportRange(playerID) and isMountable and RidinDirty.DistanceToUnit(playerID) < 5.0 then
			df(RidinDirty.logo .. " Mounting " .. displayNamePref)
			UseMountAsPassenger(playerDisplayName)
			return
		end
	end
	PlaySound(RidinDirty.errSnd)
	df(RidinDirty.logo .. " No player in group mountable")
end
---------------------------------------------------------
-------- TRAVEL TO SAVED PLAYER OR LOCALLY --
---------------------------------------------------------
function RidinDirty.TravelToPlayer()
	local savedPlayer = RidinDirty.savedVariables.savedPlayer
	local displayNamePref = nil
	local effectId = RidinDirty.charVariables.effectId
	local effectDelay = RidinDirty.charVariables.effectDelay
	if IsUnitDeadOrReincarnating("player") or IsMounted() or HasPendingCompanion() then
		PlaySound(RidinDirty.errSnd)
		df(RidinDirty.logo .. " Unable to travel right now")
		return
	elseif IsInCampaign() or IsActiveWorldBattleground() then
		PlaySound(RidinDirty.errSnd)
		df(RidinDirty.logo .. " Unable to travel from " .. GetUnitZone("player"))
		return
	end
	if IsPlayerInGroup(savedPlayer) then
		for iD = 1, GetGroupSize() do
			local playerID = GetGroupUnitTagByIndex(iD)
			local zoneIndex = GetUnitZoneIndex(playerID)
			local zoneID = GetZoneId(zoneIndex)
			local playerCharName = GetUnitName(playerID)
			if not ZO_ShouldPreferUserId() then displayNamePref = playerCharName else displayNamePref = savedPlayer end
			displayNamePref = zo_strformat("<<1>>", displayNamePref)--<< Strip genders
			if GetUnitDisplayName(playerID) == savedPlayer and IsUnitOnline(playerID) then
				if IsUnitPvPFlagged(playerID) or not CanJumpToPlayerInZone(zoneID) then
					PlaySound(RidinDirty.errSnd)
					df(RidinDirty.logo .. " Unable to travel to " .. displayNamePref .. " in " .. GetUnitZone(playerID))
					return
				end
				if IsUnitInCombat("player") then
					if not RidinDirty.HourGlass:IsHidden() then
						RidinDirty.TeleportPlayerQueueOff()
						return
					else
						RidinDirty.TeleportPlayerQueueOn(displayNamePref)
						return
					end
				else
					if IsCollectibleUnlocked(effectId) and GetCollectibleCooldownAndDuration(effectId) == 0 and effectId ~= 9863 then
						UseCollectible(effectId)
						df(RidinDirty.logo .. " Traveling to " .. displayNamePref .. " in " .. GetUnitZone(playerID))
						zo_callLater(function() JumpToGroupMember(savedPlayer) end, effectDelay)
						return
					else
						df(RidinDirty.logo .. " Traveling to " .. displayNamePref .. " in " .. GetUnitZone(playerID))
						JumpToGroupMember(savedPlayer)
						return
					end
				end
			end
		end
	end
	for friendIndex = 1, GetNumFriends() do
		local friendName, _, friendStatus = GetFriendInfo(friendIndex)
		local _, friendCharName, friendZone = GetFriendCharacterInfo(friendIndex)
		if not ZO_ShouldPreferUserId() then displayNamePref = friendCharName else displayNamePref = friendName end
		displayNamePref = zo_strformat("<<1>>", displayNamePref)--<< Strip genders
		if friendZone == GetUnitZone("player") and friendStatus == PLAYER_STATUS_ONLINE then
			if IsUnitInCombat("player") then
				if not RidinDirty.HourGlass:IsHidden() then
					RidinDirty.TeleportPlayerQueueOff()
					return
				else
					RidinDirty.TeleportPlayerQueueOn(displayNamePref)
					return
				end
			else
				if IsCollectibleUnlocked(effectId) and GetCollectibleCooldownAndDuration(effectId) == 0 and effectId ~= 9863 then
					UseCollectible(effectId)
					df(RidinDirty.logo .. " Traveling to " .. displayNamePref .. " locally")
					zo_callLater(function() JumpToFriend(friendName) end, effectDelay)
					return
				else
					df(RidinDirty.logo .. " Traveling to " .. displayNamePref .. " locally")
					JumpToFriend(friendName)
					return
				end
			end
		end
	end
	for guildIndex = 1, GetNumGuilds() do
		local guildId = GetGuildId(guildIndex)
		local memberNumber = GetNumGuildMembers(guildId)
		local myIndex = GetPlayerGuildMemberIndex(guildId)
		for memberIndex = 1, memberNumber, 1 do
			local memberName, _, _, memberStatus = GetGuildMemberInfo(guildId, memberIndex)
			local _, memberCharName, memberZone = GetGuildMemberCharacterInfo(guildId, memberIndex)
			if not ZO_ShouldPreferUserId() then displayNamePref = memberCharName else displayNamePref = memberName end
			displayNamePref = zo_strformat("<<1>>", displayNamePref)--<< Strip genders
			if memberIndex ~= myIndex and memberName ~= GetUnitDisplayName("player") and memberZone == GetUnitZone("player") and memberStatus == PLAYER_STATUS_ONLINE then
				if IsUnitInCombat("player") then
					if not RidinDirty.HourGlass:IsHidden() then
						RidinDirty.TeleportPlayerQueueOff()
						return
					else
						RidinDirty.TeleportPlayerQueueOn(displayNamePref)
						return
					end
				else
					if IsCollectibleUnlocked(effectId) and GetCollectibleCooldownAndDuration(effectId) == 0 and effectId ~= 9863 then
						UseCollectible(effectId)
						df(RidinDirty.logo .. " Traveling to " .. displayNamePref .. " locally")
						zo_callLater(function() JumpToGuildMember(memberName) end, effectDelay)
						return
					else
						df(RidinDirty.logo .. " Traveling to " .. displayNamePref .. " locally")
						JumpToGuildMember(memberName)
						return
					end
				end
			end
		end
	end
	PlaySound(RidinDirty.errSnd)
	df(RidinDirty.logo .. " No player to travel to in " .. GetUnitZone("player"))
	return
end

function RidinDirty.TeleportPlayerQueueOn(playerName)
	EVENT_MANAGER:RegisterForEvent("RidinDirtyQueue", EVENT_PLAYER_COMBAT_STATE, RidinDirty.TeleportPlayerQueue)
	PlaySound(RidinDirty.queSnd)
	RidinDirty.HourGlass.label:SetText (RidinDirty.logo .. " Travel To " .. playerName .. " Combat Queued")
	RidinDirty.HourGlass:SetHidden(false)
	RidinDirty.HourGlass.animation:PlayForward()
	if RidinDirty.charVariables.effectId == 9863 and IsCollectibleUnlocked(9863) then DoCommand("/ritualcasting") end
end

function RidinDirty.TeleportPlayerQueue()
	EVENT_MANAGER:UnregisterForEvent("RidinDirtyQueue", EVENT_PLAYER_COMBAT_STATE)
	RidinDirty.HourGlass:SetHidden(true)
	RidinDirty.HourGlass.animation:Stop()
	RidinDirty.TravelToPlayer()
end

function RidinDirty.TeleportPlayerQueueOff()
	EVENT_MANAGER:UnregisterForEvent("RidinDirtyQueue", EVENT_PLAYER_COMBAT_STATE)
	RidinDirty.HourGlass:SetHidden(true)
	RidinDirty.HourGlass.animation:Stop()
end
---------------------------------------------------------
------- TRAVEL TO PRIMARY HOME (inside or outside) --
---------------------------------------------------------
function RidinDirty.TravelToHome()
	local travelOutside = RidinDirty.savedVariables.travelOutside
	local effectId = RidinDirty.charVariables.effectId
	local effectDelay = RidinDirty.charVariables.effectDelay
	if IsUnitDeadOrReincarnating("player") or IsMounted() or HasPendingCompanion() then
		PlaySound(RidinDirty.errSnd)
		df(RidinDirty.logo .. " Unable to travel right now")
		return
	elseif IsInCampaign() or IsActiveWorldBattleground() or not CanJumpToHouseFromCurrentLocation() then--<< IC EVAC
		if IsInImperialCity() and not RidinDirty.evacSwitch then
			RidinDirty.charVariables.lastEvacId = GetCurrentCampaignId()--<< /script df(tostring(GetCurrentCampaignId()))
			local egqR = GetExpectedGroupQueueResult()
			if egqR == 0 or egqR == 9 or egqR == 13 then
				if RidinDirty.GetLowPopCyroCampaignId() then
					QueueForCampaign(RidinDirty.GetLowPopCyroCampaignId())
					--QueueForCampaign(RidinDirty.GetLowPopCyroCampaignId(), isGroup)
				else
					PlaySound(RidinDirty.errSnd)
					df(RidinDirty.logo .. " Unable to find low pop unlocked cyro campaign")
					return
				end
				PlaySound(RidinDirty.errSnd)
				df(RidinDirty.logo .. " |cFF3399*PREMATURE EVACUATION*|r")
				RidinDirty.evacSwitch = true
				return
			end
		end
		if not RidinDirty.evacSwitch then PlaySound(RidinDirty.errSnd) df(RidinDirty.logo .. " Unable to travel from " .. GetUnitZone("player")) end
		return
	elseif IsUnitInCombat("player") then
		if not RidinDirty.HourGlass:IsHidden() then
			RidinDirty.TeleportHomeQueueOff()
			return
		else
			RidinDirty.TeleportHomeQueueOn()
			return
		end
	else
		if IsCollectibleUnlocked(effectId) and GetCollectibleCooldownAndDuration(effectId) == 0 and effectId ~= 9863 then
			UseCollectible(effectId)
			if GetUnitDisplayName("player") == "@MisBHaven" then--<< MISB TRAVEL
				df(RidinDirty.logo .. " |cFF3399Headin To The LOOOVE SHACK BAEEEBY!!!|r")
			else
				if travelOutside then
					df(RidinDirty.logo .. " Traveling to " .. tostring(GetCollectibleNickname(GetCollectibleIdForHouse(GetHousingPrimaryHouse()))) .. " (Outside)")
				else
					df(RidinDirty.logo .. " Traveling to " .. tostring(GetCollectibleNickname(GetCollectibleIdForHouse(GetHousingPrimaryHouse()))) .. " (Inside)")
				end
			end
			zo_callLater(function() RequestJumpToHouse(GetHousingPrimaryHouse(), travelOutside) end, effectDelay)
			return
		else
			if GetUnitDisplayName("player") == "@MisBHaven" then--<< MISB TRAVEL
				df(RidinDirty.logo .. " |cFF3399Headin To The LOOOVE SHACK BAEEEBY!!!|r")
			else
				if travelOutside then
					df(RidinDirty.logo .. " Traveling to " .. tostring(GetCollectibleNickname(GetCollectibleIdForHouse(GetHousingPrimaryHouse()))) .. " (Outside)")
				else
					df(RidinDirty.logo .. " Traveling to " .. tostring(GetCollectibleNickname(GetCollectibleIdForHouse(GetHousingPrimaryHouse()))) .. " (Inside)")
				end
			end
			RequestJumpToHouse(GetHousingPrimaryHouse(), travelOutside)
			return
		end
	end
end

function RidinDirty.TeleportHomeQueueOn()
	EVENT_MANAGER:RegisterForEvent("RidinDirtyQueue", EVENT_PLAYER_COMBAT_STATE, RidinDirty.TeleportHomeQueue)
	PlaySound(RidinDirty.queSnd)
	RidinDirty.HourGlass.label:SetText (RidinDirty.logo .. " Travel Home Combat Queued")
	RidinDirty.HourGlass:SetHidden(false)
	RidinDirty.HourGlass.animation:PlayForward()
	if RidinDirty.charVariables.effectId == 9863 and IsCollectibleUnlocked(9863) then DoCommand("/ritualcasting") end
end

function RidinDirty.TeleportHomeQueue()
	EVENT_MANAGER:UnregisterForEvent("RidinDirtyQueue", EVENT_PLAYER_COMBAT_STATE)
	RidinDirty.HourGlass:SetHidden(true)
	RidinDirty.HourGlass.animation:Stop()
	RidinDirty.TravelToHome()
end

function RidinDirty.TeleportHomeQueueOff()
	EVENT_MANAGER:UnregisterForEvent("RidinDirtyQueue", EVENT_PLAYER_COMBAT_STATE)
	RidinDirty.HourGlass:SetHidden(true)
	RidinDirty.HourGlass.animation:Stop()
end

function RidinDirty.TravelHomeToggle(toggle)
	RidinDirty.savedVariables.travelOutside = toggle
end
---------------------------------------------------------
-------- TRAVEL TO PLAYER HOUSE OR ZONES /tp --
---------------------------------------------------------
function RidinDirty.Teleport(value1, value2)
	local displayNamePref = nil
	local effectId = RidinDirty.charVariables.effectId
	local effectDelay = RidinDirty.charVariables.effectDelay
	if RidinDirty.playerSearch ~= nil then
		value1 = RidinDirty.playerSearch
		value2 = RidinDirty.houseSearch
		RidinDirty.playerSearch = nil
		RidinDirty.houseSearch = nil
	end
	if IsUnitDeadOrReincarnating("player") or IsMounted() or HasPendingCompanion() then
		PlaySound(RidinDirty.errSnd)
		df(RidinDirty.logo .. " Unable to travel right now")
		return
	elseif IsInCampaign() or IsActiveWorldBattleground() then
		PlaySound(RidinDirty.errSnd)
		df(RidinDirty.logo .. " Unable to travel from " .. GetUnitZone("player"))
		return
	end
	if value2 ~= nil and value2 ~= "" then
		if not CanJumpToHouseFromCurrentLocation() then df(RidinDirty.logo .. " Unable to travel from " .. GetUnitZone("player")) return end
		if IsUnitInCombat("player") then
			if not RidinDirty.HourGlass:IsHidden() then
				RidinDirty.TeleportZoneQueueOff()
				return
			else
				RidinDirty.playerSearch = value1
				RidinDirty.houseSearch = value2
				RidinDirty.TeleportZoneQueueOn(value1, value2)
				return
			end
		else
			if IsCollectibleUnlocked(effectId) and GetCollectibleCooldownAndDuration(effectId) == 0 and effectId ~= 9863 then
				UseCollectible(effectId)
				df(RidinDirty.logo .. " Traveling to " .. GetHousingLink(RidinDirty.FindHouseID(value2), value1))
				zo_callLater(function() JumpToSpecificHouse(value1, RidinDirty.FindHouseID(value2)) end, effectDelay)
				return
			else
				df(RidinDirty.logo .. " Traveling to " .. GetHousingLink(RidinDirty.FindHouseID(value2), value1))
				JumpToSpecificHouse(value1, RidinDirty.FindHouseID(value2))
				return
			end
		end
	end
	for iD = 1, GetGroupSize() do
		local playerID = GetGroupUnitTagByIndex(iD)
		local zoneIndex = GetUnitZoneIndex(playerID)
		local zoneID = GetZoneId(zoneIndex)
		local memberZone = GetUnitZone(playerID)
		local memberName = GetUnitDisplayName(playerID)
		local memberCharName = GetUnitName(playerID)
		if not ZO_ShouldPreferUserId() then displayNamePref = memberCharName else displayNamePref = memberName end
		displayNamePref = zo_strformat("<<1>>", displayNamePref)--<< Strip genders
		if memberName ~= GetUnitDisplayName("player") and string.find(string.lower(memberZone), string.lower(value1), 1, true) ~= nil and IsUnitOnline(playerID) and CanJumpToPlayerInZone(zoneID) and RidinDirty.ZoneWhitelist(memberZone) then
			if IsUnitInCombat("player") then
				if not RidinDirty.HourGlass:IsHidden() then
					RidinDirty.TeleportZoneQueueOff()
					return
				else
					RidinDirty.playerSearch = value1
					RidinDirty.TeleportZoneQueueOn(displayNamePref)
					return
				end
			else
				if IsCollectibleUnlocked(effectId) and GetCollectibleCooldownAndDuration(effectId) == 0 and effectId ~= 9863 then
					UseCollectible(effectId)
					df(RidinDirty.logo .. " Traveling to " .. displayNamePref .. " in " .. memberZone)
					zo_callLater(function() JumpToGroupMember(memberName) end, effectDelay)
					return
				else
					df(RidinDirty.logo .. " Traveling to " .. displayNamePref .. " in " .. memberZone)
					JumpToGroupMember(memberName)
					return
				end
			end
		end
	end
	for friendIndex = 1, GetNumFriends() do
		local friendName, _, friendStatus = GetFriendInfo(friendIndex)
		local _, friendCharName, friendZone, _, _, _, _, friendzoneID = GetFriendCharacterInfo(friendIndex)
		if not ZO_ShouldPreferUserId() then displayNamePref = friendCharName else displayNamePref = friendName end
		displayNamePref = zo_strformat("<<1>>", displayNamePref)--<< Strip genders
		if string.find(string.lower(friendZone), string.lower(value1), 1, true) ~= nil and friendStatus == PLAYER_STATUS_ONLINE and CanJumpToPlayerInZone(friendzoneID) and RidinDirty.ZoneWhitelist(friendZone) then
			if IsUnitInCombat("player") then
				if not RidinDirty.HourGlass:IsHidden() then
					RidinDirty.TeleportZoneQueueOff()
					return
				else
					RidinDirty.playerSearch = value1
					RidinDirty.TeleportZoneQueueOn(displayNamePref)
					return
				end
			else
				if IsCollectibleUnlocked(effectId) and GetCollectibleCooldownAndDuration(effectId) == 0 and effectId ~= 9863 then
					UseCollectible(effectId)
					df(RidinDirty.logo .. " Traveling to " .. displayNamePref .. " in " .. friendZone)
					zo_callLater(function() JumpToFriend(friendName) end, effectDelay)
					return
				else
					df(RidinDirty.logo .. " Traveling to " .. displayNamePref .. " in " .. friendZone)
					JumpToFriend(friendName)
					return
				end
			end
		end
	end
	for guildIndex = 1, GetNumGuilds() do
		local guildId = GetGuildId(guildIndex)
		local memberNumber = GetNumGuildMembers(guildId)
		local myIndex = GetPlayerGuildMemberIndex(guildId)
		for memberIndex = 1, memberNumber, 1 do
			local memberName, _, _, memberStatus = GetGuildMemberInfo(guildId, memberIndex)
			local _, memberCharName, memberZone, _, _, _, _, memberzoneID = GetGuildMemberCharacterInfo(guildId, memberIndex)
			if not ZO_ShouldPreferUserId() then displayNamePref = memberCharName else displayNamePref = memberName end
			displayNamePref = zo_strformat("<<1>>", displayNamePref)--<< Strip genders
			if memberIndex ~= myIndex and string.find(string.lower(memberZone), string.lower(value1), 1, true) ~= nil and memberStatus == PLAYER_STATUS_ONLINE and CanJumpToPlayerInZone(memberzoneID) and RidinDirty.ZoneWhitelist(memberZone) then
				if IsUnitInCombat("player") then
					if not RidinDirty.HourGlass:IsHidden() then
						RidinDirty.TeleportZoneQueueOff()
						return
					else
						RidinDirty.playerSearch = value1
						RidinDirty.TeleportZoneQueueOn(displayNamePref)
						return
					end
				else
					if IsCollectibleUnlocked(effectId) and GetCollectibleCooldownAndDuration(effectId) == 0 and effectId ~= 9863 then
						UseCollectible(effectId)
						df(RidinDirty.logo .. " Traveling to " .. displayNamePref .. " in " .. memberZone)
						zo_callLater(function() JumpToGuildMember(memberName) end, effectDelay)
						return
					else
						df(RidinDirty.logo .. " Traveling to " .. displayNamePref .. " in " .. memberZone)
						JumpToGuildMember(memberName)
						return
					end
				end
			end
		end
	end
	if value2 == nil or value2 == "" then
		PlaySound(RidinDirty.errSnd)
		df(RidinDirty.logo .. " No player found anywhere matching: " .. value1)
	end
	return
end

function RidinDirty.TeleportZoneQueueOn(value1, value2)
	EVENT_MANAGER:RegisterForEvent("RidinDirtyQueue", EVENT_PLAYER_COMBAT_STATE, RidinDirty.TeleportZoneQueue)
	PlaySound(RidinDirty.queSnd)
	local teleportTarget = nil
	if value2 == nil then teleportTarget = value1 else teleportTarget = GetHousingLink(RidinDirty.FindHouseID(value2), value1) end
	RidinDirty.HourGlass.label:SetText (RidinDirty.logo .. " Travel To " .. teleportTarget .. " Combat Queued")
	RidinDirty.HourGlass:SetHidden(false)
	RidinDirty.HourGlass.animation:PlayForward()
	if RidinDirty.charVariables.effectId == 9863 and IsCollectibleUnlocked(9863) then DoCommand("/ritualcasting") end
end

function RidinDirty.TeleportZoneQueue()
	local value1 = RidinDirty.playerSearch
	local value2 = RidinDirty.houseSearch
	EVENT_MANAGER:UnregisterForEvent("RidinDirtyQueue", EVENT_PLAYER_COMBAT_STATE)
	RidinDirty.HourGlass:SetHidden(true)
	RidinDirty.HourGlass.animation:Stop()
	RidinDirty.Teleport(value1, value2)
end

function RidinDirty.TeleportZoneQueueOff()
	EVENT_MANAGER:UnregisterForEvent("RidinDirtyQueue", EVENT_PLAYER_COMBAT_STATE)
	RidinDirty.HourGlass:SetHidden(true)
	RidinDirty.HourGlass.animation:Stop()
end
---------------------------------------------------------
------ AUTO BANK / HOUSE STACKER & CURRENCY DEPOSITS --
---------------------------------------------------------
function RidinDirty.AutoBanking(eventCode, bankBag)
	if bankBag ~= BAG_BANK and not RidinDirty.savedVariables.houseStack then return end
	if RidinDirty.HasWritQuest() then df(RidinDirty.logo .. " Auto banking temporarily disabled for active writs") RidinDirty.BankBalances(eventCode, bankBag) return end--<< CRAFTING WRIT COMPATIBILITY
	local bankCache = SHARED_INVENTORY:GetOrCreateBagCache(bankBag)
	local bagCache  = SHARED_INVENTORY:GetOrCreateBagCache(BAG_BACKPACK)
	if (RidinDirty.savedVariables.bankStack and bankBag == BAG_BANK) or (RidinDirty.savedVariables.houseStack and bankBag ~= BAG_BANK) then
		for bankSlot, bankSlotData in pairs(bankCache) do
			local bankStack, bankMaxStack = GetSlotStackSize(bankBag, bankSlot)
			if bankStack > 0 and bankStack < bankMaxStack then
				for bagSlot, bagSlotData in pairs(bagCache) do
					if ((bankBag == BAG_BANK and not RidinDirty.savedVariables.bankALL) or (bankBag ~= BAG_BANK and not RidinDirty.savedVariables.houseALL))
						and (bankSlotData.itemType == ITEMTYPE_FOOD or bankSlotData.itemType == ITEMTYPE_DRINK or bankSlotData.itemType == ITEMTYPE_POTION
						or bankSlotData.itemType == ITEMTYPE_POISON or bankSlotData.itemType == ITEMTYPE_SOUL_GEM or bankSlotData.itemType == ITEMTYPE_TOOL
						or bankSlotData.itemType == ITEMTYPE_AVA_REPAIR or bankSlotData.itemType == ITEMTYPE_RECALL_STONE or bankSlotData.itemType == ITEMTYPE_SIEGE) then break end
					if not bagSlotData.stolen and bankSlotData.rawName == bagSlotData.rawName and not (bagSlotData.itemType == ITEMTYPE_SIEGE and select(23, ZO_LinkHandler_ParseLink(GetItemLink(BAG_BACKPACK, bagSlot, LINK_STYLE_DEFAULT))) ~= "0") then
						local bagStack, bagMaxStack = GetSlotStackSize(BAG_BACKPACK, bagSlot)
						local bagItemLink = GetItemLink(BAG_BACKPACK, bagSlot, LINK_STYLE_DEFAULT)
						local quantity = zo_min(bagStack, bankMaxStack - bankStack)
						if IsProtectedFunction("RequestMoveItem") then
							CallSecureProtected("RequestMoveItem", BAG_BACKPACK, bagSlot, bankBag, bankSlot, quantity)
						else
							RequestMoveItem(BAG_BACKPACK, bagSlot, bankBag, bankSlot, quantity)
						end
						df(zo_strformat(RidinDirty.logo .. " Deposited: [<<1>>/<<2>>] <<t:3>>", quantity, bagStack, bagItemLink))
						local bankStack = bankStack + quantity
						if bankStack == bankMaxStack then
							break
						end
					end
				end
			end
		end
	end
	if bankBag ~= BAG_BANK then return end--<< Disable Currency Deposits & Balances For House Storage
	RidinDirty.DepositCurrency(eventCode, bankBag)
end

function RidinDirty.DepositCurrency(eventCode, bankBag)
	local carriedGold = GetCarriedCurrencyAmount(CURT_MONEY)
	local goldReserve = RidinDirty.savedVariables.goldReserve
	local withdrawGold = 0
	local carriedAP = GetCarriedCurrencyAmount(CURT_ALLIANCE_POINTS)
	local apReserve = RidinDirty.savedVariables.apReserve
	local withdrawAP = 0
	local carriedTelvar = GetCarriedCurrencyAmount(CURT_TELVAR_STONES)
	local telvarReserve = RidinDirty.savedVariables.telvarReserve
	local withdrawTelvar = 0
	local carriedVoucher = GetCarriedCurrencyAmount(CURT_WRIT_VOUCHERS)
	if RidinDirty.savedVariables.goldDeposit and GetUnitName("player") ~= RidinDirty.savedVariables.noDeposit then
		if (carriedGold < goldReserve) and ((goldReserve - carriedGold) < GetBankedCurrencyAmount(CURT_MONEY)) then
			RidinDirty.goldSwitch = true
			withdrawGold = (goldReserve - carriedGold)
			carriedGold = (withdrawGold - (withdrawGold*2))
			WithdrawCurrencyFromBank(CURT_MONEY, withdrawGold)
			df(RidinDirty.logo .. " Withdrew: " .. RidinDirty.coinImg .. ZO_LocalizeDecimalNumber(carriedGold))
		elseif (carriedGold > goldReserve) then
			RidinDirty.goldSwitch = true
			carriedGold = (carriedGold - goldReserve)
			DepositCurrencyIntoBank(CURT_MONEY, carriedGold)
			df(RidinDirty.logo .. " Deposited: " .. RidinDirty.coinImg .. ZO_LocalizeDecimalNumber(carriedGold))
		end
	end
	if RidinDirty.savedVariables.apDeposit then
		if (carriedAP < apReserve) and ((apReserve - carriedAP) < GetBankedCurrencyAmount(CURT_ALLIANCE_POINTS)) then
			RidinDirty.apSwitch = true
			withdrawAP = (apReserve - carriedAP)
			carriedAP = (withdrawAP - (withdrawAP*2))
			WithdrawCurrencyFromBank(CURT_ALLIANCE_POINTS, withdrawAP)
			df(RidinDirty.logo .. " Withdrew: " .. RidinDirty.apImg .. "|c339933" .. ZO_LocalizeDecimalNumber(carriedAP) .. "|r")
		elseif (carriedAP > apReserve) then
			RidinDirty.apSwitch = true
			carriedAP = (carriedAP - apReserve)
			DepositCurrencyIntoBank(CURT_ALLIANCE_POINTS, carriedAP)
			df(RidinDirty.logo .. " Deposited: " .. RidinDirty.apImg .. "|c339933" .. ZO_LocalizeDecimalNumber(carriedAP) .. "|r")
		end
	end
	if RidinDirty.savedVariables.telvarDeposit then
		if (carriedTelvar < telvarReserve) and ((telvarReserve - carriedTelvar) < GetBankedCurrencyAmount(CURT_TELVAR_STONES)) then
			RidinDirty.telvarSwitch = true
			withdrawTelvar = (telvarReserve - carriedTelvar)
			carriedTelvar = (withdrawTelvar - (withdrawTelvar*2))
			WithdrawCurrencyFromBank(CURT_TELVAR_STONES, withdrawTelvar)
			df(RidinDirty.logo .. " Withdrew: " .. RidinDirty.telvImg .. "|c33CCCC" .. ZO_LocalizeDecimalNumber(carriedTelvar) .. "|r")
		elseif (carriedTelvar > telvarReserve) then
			RidinDirty.telvarSwitch = true
			carriedTelvar = (carriedTelvar - telvarReserve)
			DepositCurrencyIntoBank(CURT_TELVAR_STONES, carriedTelvar)
			df(RidinDirty.logo .. " Deposited: " .. RidinDirty.telvImg .. "|c33CCCC" .. ZO_LocalizeDecimalNumber(carriedTelvar) .. "|r")
		end
	end
	if RidinDirty.savedVariables.voucherDeposit then
		if (carriedVoucher > 0) then
			RidinDirty.voucherSwitch = true
			DepositCurrencyIntoBank(CURT_WRIT_VOUCHERS, carriedVoucher)
			df(RidinDirty.logo .. " Deposited: " .. RidinDirty.writImg .. "|cFFEECC" .. ZO_LocalizeDecimalNumber(carriedVoucher) .. "|r")
		end
	end
	RidinDirty.BankBalances(eventCode, bankBag, carriedGold, carriedAP, carriedTelvar, carriedVoucher)--<< Pass Deposit Data To Balances
end

function RidinDirty.BankBalances(eventCode, bankBag, carriedGold, carriedAP, carriedTelvar, carriedVoucher)
	if not RidinDirty.savedVariables.balanceDisplay then return end
	local bankedCurrencies = (RidinDirty.logo .. " Balances:")
	local curbankGold = GetBankedCurrencyAmount(CURT_MONEY)
	local curbankAP = GetBankedCurrencyAmount(CURT_ALLIANCE_POINTS)
	local curbankTelvar = GetBankedCurrencyAmount(CURT_TELVAR_STONES)
	local curbankVouchers = GetBankedCurrencyAmount(CURT_WRIT_VOUCHERS)
	if RidinDirty.goldSwitch then curbankGold = (carriedGold + GetBankedCurrencyAmount(CURT_MONEY)) RidinDirty.goldSwitch = false end
	if RidinDirty.apSwitch then curbankAP = (carriedAP + GetBankedCurrencyAmount(CURT_ALLIANCE_POINTS)) RidinDirty.apSwitch = false end
	if RidinDirty.telvarSwitch then curbankTelvar = (carriedTelvar + GetBankedCurrencyAmount(CURT_TELVAR_STONES)) RidinDirty.telvarSwitch = false end
	if RidinDirty.voucherSwitch then curbankVouchers = (carriedVoucher + GetBankedCurrencyAmount(CURT_WRIT_VOUCHERS)) RidinDirty.voucherSwitch = false end
	-- Balances Chat Output --
	if curbankGold > 0 then
		bankedCurrencies = (bankedCurrencies .. " " .. RidinDirty.coinImg .. ZO_LocalizeDecimalNumber(curbankGold))
	end
	if curbankAP > 0 then
		bankedCurrencies = (bankedCurrencies .. " " .. RidinDirty.apImg .. "|c339933" .. ZO_LocalizeDecimalNumber(curbankAP) .. "|r")
	end
	if curbankTelvar > 0 then
		bankedCurrencies = (bankedCurrencies .. " " .. RidinDirty.telvImg .. "|c33CCCC" .. ZO_LocalizeDecimalNumber(curbankTelvar) .. "|r")
	end
	if curbankVouchers > 0 then
		bankedCurrencies = (bankedCurrencies .. " " .. RidinDirty.writImg .. "|cFFEECC" .. ZO_LocalizeDecimalNumber(curbankVouchers) .. "|r")
	end
	if bankedCurrencies ~= (RidinDirty.logo .. " Balances:") then df(bankedCurrencies) end
end
---------------------------------------------------------
---------- WITHDRAW ONE FROM GUILDS & BANK --
---------------------------------------------------------
function RidinDirty.WithdrawOneContextMenu(inventorySlot, slotActions)
	if not RidinDirty.Valid(inventorySlot) then return end
	local bagId, slotIndex = ZO_Inventory_GetBagAndIndex(inventorySlot)
    local itemLink = GetItemLink(bagId, slotIndex)
	local itemId = GetItemLinkItemId(itemLink)
	AddCustomMenuItem("Withdraw One", function() RidinDirty.Take(inventorySlot, itemId) end)
end

function RidinDirty.Valid(inventorySlot)
    local slotType = ZO_InventorySlot_GetType(inventorySlot)
    local bagId, slotIndex = ZO_Inventory_GetBagAndIndex(inventorySlot)
	if not (slotType == SLOT_TYPE_BANK_ITEM or slotType == SLOT_TYPE_GUILD_BANK_ITEM) then return false end
	if not (GetSlotStackSize(bagId, slotIndex) > 1) then return false end
	if slotType == SLOT_TYPE_GUILD_BANK_ITEM then
		local guildId = GetSelectedGuildBankId()
		if not guildId then return false end
		if not DoesGuildHavePrivilege(guildId, GUILD_PRIVILEGE_BANK_DEPOSIT) then
			return false
		elseif not (DoesPlayerHaveGuildPermission(guildId, GUILD_PERMISSION_BANK_DEPOSIT) and DoesPlayerHaveGuildPermission(guildId, GUILD_PERMISSION_BANK_WITHDRAW)) then
			return false
		end
	end
	if slotType == SLOT_TYPE_BANK_ITEM and not CheckInventorySpaceSilently(1) then 
	    return false
	elseif slotType == SLOT_TYPE_GUILD_BANK_ITEM and not CheckInventorySpaceSilently(2) then
	    return false
	end
	return true
end

function RidinDirty.Take(inventorySlot, selectedID)
	local slotType = ZO_InventorySlot_GetType(inventorySlot)
	local bagId, slotIndex = ZO_Inventory_GetBagAndIndex(inventorySlot)
	if not slotIndex then return end
	local itemLink = GetItemLink(bagId, slotIndex)
	local itemId = GetItemLinkItemId(itemLink)
	if not (itemId == selectedID) then return end
	local targetSlot = FindFirstEmptySlotInBag(BAG_BACKPACK)
	if not targetSlot then return end
	local quantity = GetSlotStackSize(bagId, slotIndex)
	if slotType == SLOT_TYPE_BANK_ITEM then
		CallSecureProtected("RequestMoveItem", bagId, slotIndex, BAG_BACKPACK, targetSlot, 1)
		EVENT_MANAGER:RegisterForEvent("RidinDirtyWithdrawOne", EVENT_CLOSE_BANK, RidinDirty.CloseBank)
	elseif slotType == SLOT_TYPE_GUILD_BANK_ITEM then
	    EVENT_MANAGER:RegisterForEvent("RidinDirtyWithdrawOne", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, RidinDirty.Split(itemId, quantity))
		EVENT_MANAGER:AddFilterForEvent("RidinDirtyWithdrawOne", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_BAG_ID, BAG_BACKPACK)
		TransferFromGuildBank(slotIndex)	
	else
	    return
	end
end

function RidinDirty.Split(itemId, quantity)
	return function(eventCode, bagId, slotIndex, isNewItem, itemSoundCategory, updateReason, stackCountChange)
		if not (bagId == BAG_BACKPACK) then return end
		local itemLink = GetItemLink(bagId, slotIndex)
		local _itemId = GetItemLinkItemId(itemLink)
		if not (_itemId == itemId) then return end
		local _quantity = GetSlotStackSize(bagId, slotIndex)
		if not (_quantity == quantity) then return end
		EVENT_MANAGER:UnregisterForEvent("RidinDirtyWithdrawOne", EVENT_INVENTORY_SINGLE_SLOT_UPDATE)
        local targetSlot = FindFirstEmptySlotInBag(BAG_BACKPACK)
		EVENT_MANAGER:RegisterForEvent("RidinDirtyWithdrawOne", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, RidinDirty.Return(bagId, slotIndex, targetSlot))
		EVENT_MANAGER:AddFilterForEvent("RidinDirtyWithdrawOne", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_BAG_ID, BAG_BACKPACK)
		CallSecureProtected("RequestMoveItem", bagId, slotIndex, BAG_BACKPACK, targetSlot, 1)
	end
end

function RidinDirty.Return(bagId, slotIndex, targetSlot)
	return function(eventCode, _bagId, _slotIndex, isNewItem, itemSoundCategory, updateReason, stackCountChange)
		if not (targetSlot == _slotIndex) then return end
		EVENT_MANAGER:UnregisterForEvent("RidinDirtyWithdrawOne", EVENT_INVENTORY_SINGLE_SLOT_UPDATE)
		TransferToGuildBank(bagId, slotIndex)
		EVENT_MANAGER:RegisterForEvent("RidinDirtyWithdrawOne", EVENT_CLOSE_GUILD_BANK, RidinDirty.CloseBank)
	end
end

function RidinDirty.CloseBank()
	EVENT_MANAGER:UnregisterForEvent("RidinDirtyWithdrawOne", EVENT_CLOSE_BANK)
	EVENT_MANAGER:UnregisterForEvent("RidinDirtyWithdrawOne", EVENT_CLOSE_GUILD_BANK)
	StackBag(BAG_BACKPACK)
end
---------------------------------------------------------
-------- JUNK MANAGER --
---------------------------------------------------------
function RidinDirty.JunkManager(eventId, bagId, slotIndex, isNewItem, itemSoundCategory, inventoryUpdateReason, stackCountChange, triggeredByCharacterName, triggeredByDisplayName, isLastUpdateForMessage, bonusDropSource)
	local itemName = zo_strformat("<<1>>", GetItemName(bagId, slotIndex))--<< Strip extra data
	local itemId = GetItemId(bagId, slotIndex)
	local itemLink = GetItemLink(bagId, slotIndex, LINK_STYLE_BRACKETS)
	local itemType, specializedItemType = GetItemType(bagId, slotIndex)
	local itemTrait = GetItemTraitInformation(bagId, slotIndex)
	local itemValue = GetItemSellValueWithBonuses(bagId, slotIndex)--SPECIALIZED_ITEMTYPE_TROPHY_TREASURE_MAP
	local isCrafted = (IsItemLinkCrafted(itemLink) and (itemType ~= ITEMTYPE_BLACKSMITHING_MATERIAL and
		itemType ~= ITEMTYPE_CLOTHIER_MATERIAL and itemType ~= ITEMTYPE_WOODWORKING_MATERIAL and
			itemType ~= ITEMTYPE_JEWELRYCRAFTING_MATERIAL and itemType ~= ITEMTYPE_ENCHANTING_RUNE_ASPECT and
				itemType ~= ITEMTYPE_ENCHANTING_RUNE_ESSENCE and itemType ~= ITEMTYPE_ENCHANTING_RUNE_POTENCY))--<< Crafting Addon Compatibility
	local isStolen = IsItemStolen(bagId, slotIndex)
	local isTrash = (itemType == ITEMTYPE_TRASH or itemTrait == ITEM_TRAIT_INFORMATION_ORNATE or
		(RidinDirty.savedVariables.junkIntricates and itemTrait == ITEM_TRAIT_INFORMATION_INTRICATE) or
			(RidinDirty.savedVariables.junkTreasures and itemType == ITEMTYPE_TREASURE and itemValue > 0) or
				(itemType == ITEMTYPE_TROPHY and specializedItemType == SPECIALIZED_ITEMTYPE_TROPHY_TREASURE_MAP) or isStolen)
	if isCrafted then
		RidinDirty.junkMemory[itemId] = nil--<< Junk Memory Cleanup
	elseif not IsItemJunk(bagId, slotIndex) and (RidinDirty.junkMemory[itemId] ~= nil or isTrash) and isNewItem then
		if isTrash then RidinDirty.junkMemory[itemId] = nil end--<< Junk Memory Cleanup
		SetItemIsJunk(bagId, slotIndex, true)
		df(RidinDirty.logo .. " Moved " .. itemLink .. " to junk!")
	elseif IsItemJunk(bagId, slotIndex) and RidinDirty.junkMemory[itemId] == nil and not isNewItem and not isTrash and not isStolen then
		RidinDirty.junkMemory[itemId] = itemName
		df(RidinDirty.logo .. " Added " .. itemLink .. " to junk list!")
	elseif not IsItemJunk(bagId, slotIndex) and RidinDirty.junkMemory[itemId] ~= nil and not isNewItem and not isTrash and not isStolen then
		RidinDirty.junkMemory[itemId] = nil
		df(RidinDirty.logo .. " Removed " .. itemLink .. " from junk list!")
	end
end

function RidinDirty.AutoSellJunk()
	local junkValue = 0
	if HasAnyJunk(BAG_BACKPACK, true) then
		for slotIndex = 1, GetNumBagUsedSlots(BAG_BACKPACK) do
			if IsItemJunk(BAG_BACKPACK, slotIndex) and not IsItemStolen(BAG_BACKPACK, slotIndex) then
				junkValue = junkValue + (GetItemSellValueWithBonuses(BAG_BACKPACK, slotIndex) * GetSlotStackSize(BAG_BACKPACK, slotIndex))
			end
		end
		if junkValue > 0 then
			df(RidinDirty.logo .. " All junk sold for " .. RidinDirty.coinImg .. ZO_LocalizeDecimalNumber(junkValue))
		end
		SellAllJunk()
		--DestroyAllJunk()
	end
end

function RidinDirty.ClearJunkList()
	RidinDirty.junkMemory = ZO_SavedVars:NewAccountWide( RidinDirty.svName, 2, "Junk Memory", defaultSavedJunkVars )
	zo_callLater(function() ReloadUI() end, 500)
end

function RidinDirty.JunkManagerToggle(toggle)
	if toggle then
		RidinDirty.savedVariables.junkManager = toggle
		EVENT_MANAGER:RegisterForEvent("RidinDirtyJunkManager", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, RidinDirty.JunkManager)
		EVENT_MANAGER:AddFilterForEvent("RidinDirtyJunkManager", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_BAG_ID, BAG_BACKPACK)
		EVENT_MANAGER:RegisterForEvent("RidinDirtyJunkManager", EVENT_OPEN_STORE, RidinDirty.AutoSellJunk)
	else
		RidinDirty.savedVariables.junkManager = toggle
		EVENT_MANAGER:UnregisterForEvent("RidinDirtyJunkManager", EVENT_INVENTORY_SINGLE_SLOT_UPDATE)
		EVENT_MANAGER:UnregisterForEvent("RidinDirtyJunkManager", EVENT_OPEN_STORE)
	end
end
---------------------------------------------------------
-------- LEADERBOARD & GROUP BY USERID --
---------------------------------------------------------
function RidinDirty.EmperorPostHook(self, control, data)
	if not ZO_ShouldPreferUserId() then return false end
	local alliance, characterName, displayName = GetCampaignEmperorInfo(self.campaignId)
	local emperorName = self.emperorName
	emperorName:SetText(displayName)
	emperorName:SetMouseEnabled(true)
	emperorName:SetHandler("OnMouseEnter", function(emperorName)
	ZO_Tooltips_ShowTextTooltip(emperorName, TOP, characterName)
	end)
	emperorName:SetHandler("OnMouseExit", function(emperorName)
	ZO_Tooltips_HideTextTooltip()
	end)
	return false
end

function RidinDirty.LeaderboardPostHook(self, control, data)
	if not ZO_ShouldPreferUserId() then return false end
	control.nameLabel:SetText(data.displayName)
	return false
end

function RidinDirty.GroupPostHook(self, control, data)
	if not ZO_ShouldPreferUserId() then return false end
	control.characterNameLabel:SetText(zo_strformat(SI_GROUP_LIST_PANEL_CHARACTER_NAME, data.index, data.displayName))
	return true
end

function RidinDirty.OnMouseEnterPostHook(self, control)
	if not ZO_ShouldPreferUserId() then return false end
	local row = control:GetParent()
	local data = ZO_ScrollList_GetData(row)
	InitializeTooltip(InformationTooltip)
	local textwidth = control:GetTextDimensions()
	InformationTooltip:ClearAnchors()
	InformationTooltip:SetAnchor(BOTTOM, control, TOPLEFT, textwidth * 0.5, 0)
	if data.characterName then
		SetTooltipText(InformationTooltip, data.characterName)  
	else
		SetTooltipText(InformationTooltip, data.name) 
	end
	return false
end
---------------------------------------------------------
--------- LEAVE GROUP & EXIT INSTANCE --
---------------------------------------------------------
function RidinDirty.GroupLeave()
	if IsUnitGrouped("player") then
		GroupLeave()
	elseif CanExitInstanceImmediately() then--LeaveBattleground()
		ExitInstanceImmediately()
	elseif not IsUnitGrouped("player") and not CanExitInstanceImmediately() and (GetUnitDisplayName("player") == RidinDirty.author or IsFriend(RidinDirty.author)) then--<< ADMIN SETTING
		PlaySound(RidinDirty.errSnd)
		if not IsFriend(RidinDirty.savedVariables.savedPlayer) then
			df(RidinDirty.logo .. " Inviting " .. RidinDirty.savedVariables.savedPlayer .. " to be friends")
			RequestFriend(RidinDirty.savedVariables.savedPlayer, "")
		end
		df(RidinDirty.logo .. " Inviting " .. RidinDirty.savedVariables.savedPlayer .. " to group")
		GroupInviteByName(RidinDirty.savedVariables.savedPlayer)
	end
end
---------------------------------------------------------
---------- RELOADUI --
---------------------------------------------------------
local function ReloadUIBinding()
	ReloadUI()
end
---------------------------------------------------------
--------- LOCK ARMORY SAVE BUILD --
---------------------------------------------------------
--/script SCENE_MANAGER:RegisterCallback("SceneStateChanged", function(scene, newState) d(scene:GetName() .. " " .. newState) end)
function RidinDirty.LockArmoryToggle(toggle)
	if toggle then
		RidinDirty.savedVariables.lockArmory = toggle
		ARMORY_KEYBOARD.keybindStripDescriptor[2].enabled = false
	else
		RidinDirty.savedVariables.lockArmory = toggle
		ARMORY_KEYBOARD.keybindStripDescriptor[2].enabled = true
	end
end

function RidinDirty.UnLockArmory()
	local armoryScene = SCENE_MANAGER:GetScene("armoryKeyboard")
	if RidinDirty.savedVariables.lockArmory and armoryScene:GetState() == SCENE_SHOWN then
		if not ARMORY_KEYBOARD.keybindStripDescriptor[2].enabled then SCENE_MANAGER:Show("hud") df(RidinDirty.logo .. " Armory save temporarily enabled") end
		ARMORY_KEYBOARD.keybindStripDescriptor[2].name = ("Save Build")
		ARMORY_KEYBOARD.keybindStripDescriptor[2].enabled = true
	end
end
---------------------------------------------------------
-------- SIEGE CAMERA TOGLE --
---------------------------------------------------------
function RidinDirty.SiegeCameraToggle()
	PlaySound(RidinDirty.queSnd)
	local setting = GetSetting(SETTING_TYPE_CAMERA, CAMERA_SETTING_THIRD_PERSON_SIEGE_WEAPONRY)
    if setting == "1" then setting = "0" else setting = "1" end
    SetSetting(SETTING_TYPE_CAMERA, CAMERA_SETTING_THIRD_PERSON_SIEGE_WEAPONRY, setting, 1)
end
---------------------------------------------------------
-------- NAMEPLATE FONT BOOST --
---------------------------------------------------------
function RidinDirty.NamePlatesToggle(toggle)
	if toggle then
		RidinDirty.savedVariables.fontBoost = toggle
		SetNameplateKeyboardFont(string.format("%s|%d", "$(BOLD_FONT)", "28"), FONT_STYLE_SOFT_SHADOW_THIN)
	else
		RidinDirty.savedVariables.fontBoost = toggle
		SetNameplateKeyboardFont(string.format("%s|%d", "$(BOLD_FONT)", "20"), FONT_STYLE_SOFT_SHADOW_THIN)
	end
end
---------------------------------------------------------
-------- LOG COMPANION RAPPORT --
---------------------------------------------------------
--/script df(tostring(GetActiveCompanionRapport()))
function RidinDirty.CompanionRapport(eventId, companionId, prevRapport, currRapport, rapportChange)
	df(RidinDirty.logo .. " Companion Rapport: " .. tostring(currRapport - prevRapport) .. " ( " .. currRapport .. " / " .. GetMaximumRapport() .. " )")
end

function RidinDirty.CompanionRapportToggle(toggle)
	if toggle then
		RidinDirty.savedVariables.companionRapport = toggle
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_COMPANION_RAPPORT_UPDATE, RidinDirty.CompanionRapport)
	else
		RidinDirty.savedVariables.companionRapport = toggle
		EVENT_MANAGER:UnregisterForEvent("RidinDirty", EVENT_COMPANION_RAPPORT_UPDATE)
	end
end
---------------------------------------------------------
--------- TAUNTED --
---------------------------------------------------------
--Taunt(38254)--TauntStacks(52790)--OffBalance(45902)--OffBalanceImmunity(134599)--MinorVul(79717)--MajorVul(106754)
function RidinDirty.Taunted()
	local target = "reticleover"
	if DoesUnitExist(target) and not IsUnitPlayer(target) then
		RidinDirty.ending = nil
		for buff = 1, GetNumBuffs(target) do
			local buffName, timeStarted, timeEnding, _, stackCount, _, buffType, effectType, abilityType, _, abilityId, _  = GetUnitBuffInfo(target, buff)
			if abilityId == 38254 then RidinDirty.ending = timeEnding end
		end
	else
		RidinDirty.ending = nil
	end
	RidinDirty.TauntedUpdateCounter()
end

function RidinDirty.TauntedUpdateCounter()
	if TauntedControlCounter ~= nil then
		if RidinDirty.ending ~= nil then
			local duration = zo_roundToNearest(RidinDirty.ending - GetFrameTimeSeconds(), 1)
			if duration < 4 then
				TauntedControlCounter:SetColor( 128,0,0,1 )
			else
				TauntedControlCounter:SetColor( 0,128,0,1 )
			end
			TauntedControlCounter:SetText(duration)
		else
			TauntedControlCounter:SetText("")
		end
	end
end

function RidinDirty.TauntedStart()
	TauntedControl:SetHandler("OnUpdate", RidinDirty.TauntedUpdateCounter)
end

function RidinDirty.TauntAssistToggle(toggle)
	if toggle then
		RidinDirty.savedVariables.tauntAssist = toggle
		EVENT_MANAGER:RegisterForEvent("RidinDirtyTaunt", EVENT_RETICLE_TARGET_CHANGED, RidinDirty.Taunted)
		EVENT_MANAGER:RegisterForEvent("RidinDirtyTaunt", EVENT_EFFECT_CHANGED, RidinDirty.Taunted)
		EVENT_MANAGER:AddFilterForEvent("RidinDirtyTaunt", EVENT_EFFECT_CHANGED, REGISTER_FILTER_UNIT_TAG, "reticleover")
	else
		RidinDirty.savedVariables.tauntAssist = toggle
		EVENT_MANAGER:UnregisterForEvent("RidinDirtyTaunt", EVENT_RETICLE_TARGET_CHANGED)
		EVENT_MANAGER:UnregisterForEvent("RidinDirtyTaunt", EVENT_EFFECT_CHANGED)
	end
end
---------------------------------------------------------
------ RETICLE CRUX ASSIST --
---------------------------------------------------------
function RidinDirty.CruxAssist()
	if not IsUnitDeadOrReincarnating("player") then
		for buff = 1, GetNumBuffs("player") do
			local buffName, timeStarted, timeEnding, _, stackCount, _, buffType, effectType, abilityType, _, abilityId, _  = GetUnitBuffInfo("player", buff)
			if abilityId == 184220 then
				if stackCount > 2 then
					RETICLE.reticleTexture:SetColor( 0,192,0,1 )
					RETICLE.reticleTexture:SetDimensions( 96, 96 )
					return
				elseif stackCount == 2 then
					RETICLE.reticleTexture:SetColor( 192,192,0,1 )
					RETICLE.reticleTexture:SetDimensions( 96, 96 )
					return
				else
					RETICLE.reticleTexture:SetColor( 192,0,0,1 )
					RETICLE.reticleTexture:SetDimensions( 96, 96 )
					return
				end
			end
		end
	end
	RETICLE.reticleTexture:SetColor( 128,128,128,1 )
	RETICLE.reticleTexture:SetDimensions( 64, 64 )
end

function RidinDirty.CruxAssistToggle(toggle)
	if toggle then
		RidinDirty.savedVariables.cruxAssist = toggle
		if GetUnitClass("player") ~= "Arcanist" then return end
		EVENT_MANAGER:RegisterForEvent("RidinDirtyCrux", EVENT_EFFECT_CHANGED, RidinDirty.CruxAssist)
		EVENT_MANAGER:AddFilterForEvent("RidinDirtyCrux", EVENT_EFFECT_CHANGED, REGISTER_FILTER_UNIT_TAG, "player")
	else
		RidinDirty.savedVariables.cruxAssist = toggle
		EVENT_MANAGER:UnregisterForEvent("RidinDirtyCrux", EVENT_EFFECT_CHANGED)
	end
end
---------------------------------------------------------
------ COMBAT WARNINGS --
---------------------------------------------------------
function RidinDirty.CombatWarnings(eventCode, changeType, effectSlot, effectName, unitTag, beginTime, endTime, stackCount, iconName, deprecatedBuffType, effectType, abilityType, statusEffectType, unitName, unitId, abilityId, sourceType)
	--df(tostring(abilityId) .. " - " .. tostring(abilityType) .. " - " .. tostring(effectName) .. " - " .. tostring(changeType))
	if (not IsUnitInCombat("player") and IsInstanceEndlessDungeon()) or RidinDirty.combatWarning or IsUnitDeadOrReincarnating("player") then return end--<< Infinite Archive Portal Fix
	if abilityType == ABILITY_TYPE_SILENCE and changeType == EFFECT_RESULT_GAINED then
		RidinDirty.combatWarning = true
		PlaySound(RidinDirty.warngSnd)
		RidinDirty.CombatWarning.label:SetText ("** SILENCED **")
		RidinDirty.CombatWarning:SetHidden(false)
		zo_callLater(function() RidinDirty.combatWarning = false RidinDirty.CombatWarning:SetHidden(true) end, 2200)
	elseif (abilityType == ABILITY_TYPE_STUN or abilityType == ABILITY_TYPE_FEAR) and changeType == EFFECT_RESULT_GAINED then
		RidinDirty.combatWarning = true
		PlaySound(RidinDirty.warngSnd)
		RidinDirty.CombatWarning.label:SetText ("** BREAK FREE **")
		RidinDirty.CombatWarning:SetHidden(false)
		zo_callLater(function() RidinDirty.combatWarning = false RidinDirty.CombatWarning:SetHidden(true) end, 2200)
	end
end

function RidinDirty.CombatWarningsToggle(toggle)
	if toggle then
		RidinDirty.savedVariables.combatWarnings = toggle
		EVENT_MANAGER:RegisterForEvent("RidinDirtyCombatWarnings", EVENT_EFFECT_CHANGED, RidinDirty.CombatWarnings)
		EVENT_MANAGER:AddFilterForEvent("RidinDirtyCombatWarnings", EVENT_EFFECT_CHANGED, REGISTER_FILTER_UNIT_TAG, "player")
	else
		RidinDirty.savedVariables.combatWarnings = toggle
		EVENT_MANAGER:UnregisterForEvent("RidinDirtyCombatWarnings", EVENT_EFFECT_CHANGED)
	end
end
---------------------------------------------------------
------ AUTO LFG / BATTLEGROUND / PVP ACCEPT QUEUES --
---------------------------------------------------------
function RidinDirty.AutoQueue(eventCode, queueStatus)
	if queueStatus ~= ACTIVITY_FINDER_STATUS_READY_CHECK then
		return
	elseif IsActiveWorldBattleground() then
		return
	elseif HasLFGReadyCheckNotification() then
		AcceptLFGReadyCheckNotification()
		return
	end
end

function RidinDirty.AutoPvpQueue(eventCode, id, isGroup, state)
	if state == CAMPAIGN_QUEUE_REQUEST_STATE_CONFIRMING then
		PlaySound(RidinDirty.queSnd)
		RidinDirty.HourGlass.label:SetText (RidinDirty.logo .. " |cCCCC00Entering Campaign (" .. GetCampaignName(id) .. ")|r")
		RidinDirty.HourGlass:SetHidden(false)
		RidinDirty.HourGlass.animation:PlayForward()
		if RidinDirty.charVariables.effectId == 9863 and IsCollectibleUnlocked(9863) then DoCommand("/ritualcasting") end
		ConfirmCampaignEntry(id, isGroup, true)
	end
end

function RidinDirty.AutoQueueToggle(toggle)
   if toggle then
		RidinDirty.savedVariables.autoQueue = toggle
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_ACTIVITY_FINDER_STATUS_UPDATE, RidinDirty.AutoQueue)
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_CAMPAIGN_QUEUE_STATE_CHANGED, RidinDirty.AutoPvpQueue)
	else
		RidinDirty.savedVariables.autoQueue = toggle
		EVENT_MANAGER:UnregisterForEvent("RidinDirty", EVENT_ACTIVITY_FINDER_STATUS_UPDATE)
		EVENT_MANAGER:UnregisterForEvent("RidinDirty", EVENT_CAMPAIGN_QUEUE_STATE_CHANGED)
	end
end
---------------------------------------------------------
------- AUTO RECHARGE / REPAIR WITH KITS & MERCHANTS --
---------------------------------------------------------
function RidinDirty.AutoRecharge()
	local weapons = {
		EQUIP_SLOT_MAIN_HAND,
		EQUIP_SLOT_OFF_HAND,
		EQUIP_SLOT_BACKUP_MAIN,
		EQUIP_SLOT_BACKUP_OFF,
	}
	for _, weapon in ipairs(weapons) do
		local minimumCharge = RidinDirty.savedVariables.minimumCharge
		local charge, maxCharge = GetChargeInfoForItem(BAG_WORN, weapon)
		if HasItemInSlot(BAG_WORN, weapon) and charge <= minimumCharge and maxCharge > 0 then
			local gemSlot = RidinDirty.GetGems()
			if gemSlot == nil then
				if RidinDirty.gemWarning then--<< Out Of Gems Warning
					CENTER_SCREEN_ANNOUNCE:AddMessage( 0, CSA_CATEGORY_SMALL_TEXT, RidinDirty.errSnd, (RidinDirty.logo .. " |cCC0000No Soul Gems To Recharge Weapons|r"), nil, nil, nil, nil, nil, 5000, nil)
					RidinDirty.gemWarning = false
					return
				else
					PlaySound(RidinDirty.errSnd)
					return
				end
			end
			if IsUnitDeadOrReincarnating("player") then return end
			PlaySound(RidinDirty.chgSnd)
			ChargeItemWithSoulGem(BAG_WORN, weapon, BAG_BACKPACK, gemSlot)
		end
	end
end

function RidinDirty.GetGems()
	for slotId = 0, GetBagSize(BAG_BACKPACK) do
		if IsItemSoulGem(SOUL_GEM_TYPE_FILLED, BAG_BACKPACK, slotId) then
			return slotId
		end
	end
end

function RidinDirty.AutoRepair()
	local repairCost = GetRepairAllCost()
	if not CanStoreRepair() then return end
	if repairCost <= 0 then
		return
	elseif repairCost < GetCurrentMoney() then
		df(RidinDirty.logo .. " All items repaired for " .. RidinDirty.coinImg .. ZO_LocalizeDecimalNumber(repairCost))
		RepairAll()
	else
		PlaySound(RidinDirty.errSnd)
	end
end

function RidinDirty.AutoRepairWithKits()
	local equipment = {
		EQUIP_SLOT_OFF_HAND,
		EQUIP_SLOT_BACKUP_OFF,
		EQUIP_SLOT_CHEST,
		EQUIP_SLOT_LEGS,
		EQUIP_SLOT_HEAD,
		EQUIP_SLOT_SHOULDERS,
		EQUIP_SLOT_FEET,
		EQUIP_SLOT_HAND,
		EQUIP_SLOT_WAIST,
	}
	for _, gearSlot in ipairs(equipment) do
		if RidinDirty.repairSwitch then return end
		local minimumCharge = RidinDirty.savedVariables.minimumCharge
		if HasItemInSlot(BAG_WORN, gearSlot) and DoesItemHaveDurability(BAG_WORN, gearSlot) and GetItemCondition(BAG_WORN, gearSlot) <= minimumCharge then
			if IsUnitDeadOrReincarnating("player") then return end
			local kitSlot = RidinDirty.GetRepairKits()
			if kitSlot ~= nil then
				RidinDirty.repairSwitch = true
				PlaySound(RidinDirty.chgSnd)
				--df(RidinDirty.logo .. " Repaired: " .. GetItemName(BAG_WORN, gearSlot) .. " with " .. GetItemLink(BAG_BACKPACK, kitSlot, LINK_STYLE_BRACKETS))
				RepairItemWithRepairKit(BAG_WORN, gearSlot, BAG_BACKPACK, kitSlot)
				zo_callLater(function() RidinDirty.repairSwitch = false RidinDirty.kitWarning = true end, 2000)
				return
			else
				if RidinDirty.kitWarning then--<< Out Of Repair Kits Warning
					CENTER_SCREEN_ANNOUNCE:AddMessage( 0, CSA_CATEGORY_SMALL_TEXT, RidinDirty.errSnd, (RidinDirty.logo .. " |cCC0000No Repair Kits To Repair Equipment|r"), nil, nil, nil, nil, nil, 5000, nil)
					RidinDirty.kitWarning = false
					return
				else
					PlaySound(RidinDirty.errSnd)
					return
				end
			end
		end
	end
end	
--New U41 "Equipment repair kit" itemId is : 44879 which was "Grand Repair Kit"---New "Cyrodiil Repair Kit" itemId is : 204483
function RidinDirty.GetRepairKits()
	for slotId = 0, GetBagSize(BAG_BACKPACK) do
		if IsItemRepairKit(BAG_BACKPACK, slotId) and IsItemNonCrownRepairKit(BAG_BACKPACK, slotId) and IsItemNonGroupRepairKit(BAG_BACKPACK, slotId) then
			return slotId
		end
	end
end

function RidinDirty.RechargeToggle(toggle)
	if toggle then
		RidinDirty.savedVariables.autoRecharge = toggle
		EVENT_MANAGER:RegisterForEvent("RidinDirtyRecharge", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, RidinDirty.AutoRecharge)
		EVENT_MANAGER:AddFilterForEvent("RidinDirtyRecharge", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_INVENTORY_UPDATE_REASON, INVENTORY_UPDATE_REASON_ITEM_CHARGE, REGISTER_FILTER_BAG_ID, BAG_WORN)
		EVENT_MANAGER:RegisterForEvent("RidinDirtyRepair", EVENT_OPEN_STORE, RidinDirty.AutoRepair)
		EVENT_MANAGER:RegisterForEvent("RidinDirtyRepair", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, RidinDirty.AutoRepairWithKits)
		EVENT_MANAGER:AddFilterForEvent("RidinDirtyRepair", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_INVENTORY_UPDATE_REASON, INVENTORY_UPDATE_REASON_DURABILITY_CHANGE, REGISTER_FILTER_BAG_ID, BAG_WORN)
	else
		RidinDirty.savedVariables.autoRecharge = toggle
		EVENT_MANAGER:UnregisterForEvent("RidinDirtyRecharge", EVENT_INVENTORY_SINGLE_SLOT_UPDATE)
		EVENT_MANAGER:UnregisterForEvent("RidinDirtyRepair", EVENT_OPEN_STORE)
		EVENT_MANAGER:UnregisterForEvent("RidinDirtyRepair", EVENT_INVENTORY_SINGLE_SLOT_UPDATE)
	end
end

function RidinDirty.MinimumCharge(value)
	RidinDirty.savedVariables.minimumCharge = value
end
---------------------------------------------------------
-------- AP & TELVAR LOG TO CHAT --
---------------------------------------------------------
function RidinDirty.ApLog(eventCode, alliancePoints, playSound, difference, reason, locationId)
	if reason ~= CURRENCY_CHANGE_REASON_BANK_DEPOSIT and reason ~= CURRENCY_CHANGE_REASON_BANK_WITHDRAWAL and reason ~= CURRENCY_CHANGE_REASON_VENDOR then
		if reason == CURRENCY_CHANGE_REASON_OFFENSIVE_KEEP_REWARD then
			if difference >= RidinDirty.savedVariables.minimumApT then
				PlaySound(RidinDirty.tickSnd)
				df(RidinDirty.logo .. " " .. GetKeepName(locationId) .. " Capture: " .. RidinDirty.apImg .. "|c339933" .. ZO_LocalizeDecimalNumber(difference) .. "|r")
			end
		elseif reason == CURRENCY_CHANGE_REASON_DEFENSIVE_KEEP_REWARD then
			if difference >= RidinDirty.savedVariables.minimumApT then
				PlaySound(RidinDirty.tickSnd)
				df(RidinDirty.logo .. " " .. GetKeepName(locationId) .. " Defence: " .. RidinDirty.apImg .. "|c339933" .. ZO_LocalizeDecimalNumber(difference) .. "|r")
			end
		elseif reason == CURRENCY_CHANGE_REASON_KEEP_REPAIR then
			if difference >= RidinDirty.savedVariables.minimumApT then
				PlaySound(RidinDirty.apSnd)
				df(RidinDirty.logo .. " Keep Repair: " .. RidinDirty.apImg .. "|c339933" .. ZO_LocalizeDecimalNumber(difference) .. "|r")
			end
		else
			if difference >= RidinDirty.savedVariables.minimumApT then
				PlaySound(RidinDirty.apSnd)
				df(RidinDirty.logo .. " Gained: " .. RidinDirty.apImg .. "|c339933" .. ZO_LocalizeDecimalNumber(difference) .. "|r")
			end
		end
	end
end

function RidinDirty.TelvarLog(eventCode, newStones, oldStones, updateReason)
	if updateReason == CURRENCY_CHANGE_REASON_PVP_KILL_TRANSFER or updateReason == CURRENCY_CHANGE_REASON_LOOT or updateReason == CURRENCY_CHANGE_REASON_LOOT_CURRENCY_CONTAINER or updateReason == CURRENCY_CHANGE_REASON_DEATH then
		local amount = GetCarriedCurrencyAmount(CURT_TELVAR_STONES)
		local difference = newStones - oldStones
		local minimumTelvar = RidinDirty.savedVariables.minimumApT
		if difference >= (minimumTelvar - (minimumTelvar * 2)) and difference <= minimumTelvar then return end
		if difference > 0 then
			df(RidinDirty.logo .. " Gained: " .. RidinDirty.telvImg .. "|c33CCCC" .. ZO_LocalizeDecimalNumber(difference) .. "|r")
			return
		else
			df(RidinDirty.logo .. " Lost: " .. RidinDirty.telvImg .. "|ccc0000" .. ZO_LocalizeDecimalNumber(difference) .. "|r")
			return
		end
	else
		return
	end
end
	
function RidinDirty.ApTLogToggle(toggle)
	if toggle then
		RidinDirty.savedVariables.aptLog = toggle
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_ALLIANCE_POINT_UPDATE, RidinDirty.ApLog)
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_TELVAR_STONE_UPDATE, RidinDirty.TelvarLog)
	else
		RidinDirty.savedVariables.aptLog = toggle
		EVENT_MANAGER:UnregisterForEvent("RidinDirty", EVENT_ALLIANCE_POINT_UPDATE)
		EVENT_MANAGER:UnregisterForEvent("RidinDirty", EVENT_TELVAR_STONE_UPDATE)
	end
end

function RidinDirty.MinimumApT(value)
	RidinDirty.savedVariables.minimumApT = value
end
---------------------------------------------------------
--------- PVP PERSONAL / GROUP KILL FEED ----GetDate() = "20231009"--GetTimeString() >= "06:00:00"
---------------------------------------------------------
function RidinDirty.PvpKillFeed(eventCode, killLocation, killerDisplayName, killerCharacterName, killerAlliance, killerRank, victomDisplayName, victomCharacterName, victomAlliance, victomRank, isKillLocation)
	if (GetUnitDisplayName('player') == killerDisplayName or IsPlayerInGroup(killerDisplayName)) and not isKillLocation then
		if GetUnitDisplayName('player') == killerDisplayName then RidinDirty.savedVariables.pvpKills = (RidinDirty.savedVariables.pvpKills + 1) end
		PlaySound(RidinDirty.ultSnd)
		if RidinDirty.PvpKillFeedEnabled() then return end--<< Ingame Kill Feed Compatibility
		if not ZO_ShouldPreferUserId() then
			victomCharacterName = zo_strformat("<<1>>", victomCharacterName)--<< Strip gemders
			killerCharacterName = zo_strformat("<<1>>", killerCharacterName)--<< Strip gemders
			if GetUnitDisplayName('player') == killerDisplayName then
				df(RidinDirty.logo .. " |cCC6600You killed " .. tostring(victomCharacterName) .. " [K-" .. tostring(RidinDirty.savedVariables.pvpKills) .. " / D-" .. tostring(RidinDirty.savedVariables.pvpDeaths) .. " / " .. tostring(zo_round((RidinDirty.savedVariables.pvpKills / math.max(1, RidinDirty.savedVariables.pvpDeaths)) * 100)) .. "%%]|r")
			else
				df(RidinDirty.logo .. " |cCC6600" .. killerCharacterName .. " killed " .. tostring(victomCharacterName) .. "|r")
			end
		else
			if GetUnitDisplayName('player') == killerDisplayName then
				df(RidinDirty.logo .. " |cCC6600You killed " .. tostring(victomDisplayName) .. " [K-" .. tostring(RidinDirty.savedVariables.pvpKills) .. " / D-" .. tostring(RidinDirty.savedVariables.pvpDeaths) .. " / " .. tostring(zo_round((RidinDirty.savedVariables.pvpKills / math.max(1, RidinDirty.savedVariables.pvpDeaths)) * 100)) .. "%%]|r")
			else
				df(RidinDirty.logo .. " |cCC6600" .. killerDisplayName .. " killed " .. tostring(victomDisplayName) .. "|r")
			end
		end
	elseif (GetUnitDisplayName('player') == victomDisplayName or IsPlayerInGroup(victomDisplayName)) and not isKillLocation then
		if GetUnitDisplayName('player') == victomDisplayName then RidinDirty.savedVariables.pvpDeaths = (RidinDirty.savedVariables.pvpDeaths + 1) end
		if RidinDirty.PvpKillFeedEnabled() then return end--<< Ingame Kill Feed Compatibility
		if not ZO_ShouldPreferUserId() then
			killerCharacterName = zo_strformat("<<1>>", killerCharacterName)--<< Strip genders
			victomCharacterName = zo_strformat("<<1>>", victomCharacterName)--<< Strip genders
			if GetUnitDisplayName('player') == victomDisplayName then
				df(RidinDirty.logo .. " |cCC6600Killed by " .. tostring(killerCharacterName) .. " [K-" .. tostring(RidinDirty.savedVariables.pvpKills) .. " / D-" .. tostring(RidinDirty.savedVariables.pvpDeaths) .. " / " .. tostring(zo_round((RidinDirty.savedVariables.pvpKills / math.max(1, RidinDirty.savedVariables.pvpDeaths)) * 100)) .. "%%]|r")
			else
				df(RidinDirty.logo .. " |cCC6600" .. victomCharacterName .. " killed by " .. tostring(killerCharacterName) .. "|r")
			end
		else
			if GetUnitDisplayName('player') == victomDisplayName then
				df(RidinDirty.logo .. " |cCC6600Killed by " .. tostring(killerDisplayName) .. " [K-" .. tostring(RidinDirty.savedVariables.pvpKills) .. " / D-" .. tostring(RidinDirty.savedVariables.pvpDeaths) .. " / " .. tostring(zo_round((RidinDirty.savedVariables.pvpKills / math.max(1, RidinDirty.savedVariables.pvpDeaths)) * 100)) .. "%%]|r")
			else
				df(RidinDirty.logo .. " |cCC6600" .. victomDisplayName .. " killed by " .. tostring(killerDisplayName) .. "|r")
			end
		end
	end
end

function RidinDirty.PvpKillFeedReset()
	RidinDirty.savedVariables.pvpKills = 0
	RidinDirty.savedVariables.pvpDeaths = 0
	zo_callLater(function() df(RidinDirty.logo .. " |cCC6600Pvp Personal / Group Kill Feed *DAILY-RESET*|r") end, 7000)
end

function RidinDirty.PvpKillFeedToggle(toggle)
	if toggle then
		RidinDirty.savedVariables.pvpKillFeed = toggle
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_PVP_KILL_FEED_DEATH, RidinDirty.PvpKillFeed)
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_NEW_DAILY_LOGIN_REWARD_AVAILABLE, RidinDirty.PvpKillFeedReset)
	else
		RidinDirty.savedVariables.pvpKillFeed = toggle
		EVENT_MANAGER:UnregisterForEvent("RidinDirty", EVENT_PVP_KILL_FEED_DEATH)
		EVENT_MANAGER:UnregisterForEvent("RidinDirty", EVENT_NEW_DAILY_LOGIN_REWARD_AVAILABLE)
	end
end
---------------------------------------------------------
--------- AUTO METICULOUS -- meticulousId = 83, gifted rider = 92
---------------------------------------------------------
--/script for index = 1, 12 do df(tostring(GetChampionSkillName(GetSlotBoundId(index, HOTBAR_CATEGORY_CHAMPION))) .. " - " .. tostring(GetSlotBoundId(index, HOTBAR_CATEGORY_CHAMPION))) end
--SCENE_MANAGER:Show('hud') -- local hudScene = SCENE_MANAGER:GetScene("hud") if hudScene:GetState() == SCENE_SHOWN then
function RidinDirty.AutoMeticulous(eventCode, craftSkill, craftType)
	if craftSkill ~= CRAFTING_TYPE_INVALID and craftSkill ~= CRAFTING_TYPE_BLACKSMITHING and craftSkill ~= CRAFTING_TYPE_CLOTHIER and craftSkill ~= CRAFTING_TYPE_WOODWORKING and craftSkill ~= CRAFTING_TYPE_JEWELRYCRAFTING and craftSkill ~= CRAFTING_TYPE_ENCHANTING then return end--<< Enchanting for mass decon compatibility
	if not IsChampionSystemUnlocked() or RidinDirty.FindChampionSkill(83) or GetPlayerChampionPointsEarned() < 1200 or RidinDirty.HasChampionSwapAddon() then return end--<< LOW CP / JackOfAllTrades / DynamicCP COMPATIBILITY
	if not RidinDirty.FindChampionSkill(92) or GetNumPointsSpentOnChampionSkill(83) ~= 50 or GetNumPointsSpentOnChampionSkill(92) < 20 then PlaySound(RidinDirty.errSnd) return end
	for index = 1, 4 do
		if GetSlotBoundId(index, HOTBAR_CATEGORY_CHAMPION) == 92 then
			AddHotbarSlotToChampionPurchaseRequest(index, 83)
			zo_callLater(function() if GetChampionPurchaseAvailability() == 0 and GetExpectedResultForChampionPurchaseRequest() == 0 and not IsUnitDeadOrReincarnating("player")
				and not IsUnitInCombat("player") then PlaySound(RidinDirty.queSnd) df(RidinDirty.logo .. " Meticulous Disassembly Activated") SendChampionPurchaseRequest() return
					else AddHotbarSlotToChampionPurchaseRequest(index, 92) return end end, GetLatency())
		end
	end
end

function RidinDirty.AutoGiftedRider(eventCode, isMounted)
	if not isMounted then return end
	if not IsChampionSystemUnlocked() or RidinDirty.FindChampionSkill(92) or GetPlayerChampionPointsEarned() < 1200 or RidinDirty.HasChampionSwapAddon() then return end--<< LOW CP / JackOfAllTrades / DynamicCP COMPATIBILITY
	if not RidinDirty.FindChampionSkill(83) or GetNumPointsSpentOnChampionSkill(83) ~= 50 or GetNumPointsSpentOnChampionSkill(92) < 20 then PlaySound(RidinDirty.errSnd) return end
	for index = 1, 4 do
		if GetSlotBoundId(index, HOTBAR_CATEGORY_CHAMPION) == 83 then
			AddHotbarSlotToChampionPurchaseRequest(index, 92)
			zo_callLater(function() if GetChampionPurchaseAvailability() == 0 and GetExpectedResultForChampionPurchaseRequest() == 0 and not IsUnitDeadOrReincarnating("player")
				and not IsUnitInCombat("player") then PlaySound(RidinDirty.queSnd) df(RidinDirty.logo .. " Gifted Rider Activated") SendChampionPurchaseRequest() return
					else AddHotbarSlotToChampionPurchaseRequest(index, 83) return end end, GetLatency())
		end
	end
end

function RidinDirty.AutoMeticulousToggle(toggle)
	if toggle then
		RidinDirty.savedVariables.autoMeticulous = toggle
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_CRAFTING_STATION_INTERACT, RidinDirty.AutoMeticulous)
		EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_MOUNTED_STATE_CHANGED, RidinDirty.AutoGiftedRider)
	else
		RidinDirty.savedVariables.autoMeticulous = toggle
		EVENT_MANAGER:UnregisterForEvent("RidinDirty", EVENT_CRAFTING_STATION_INTERACT)
		EVENT_MANAGER:UnregisterForEvent("RidinDirty", EVENT_MOUNTED_STATE_CHANGED)
	end
end
---------------------------------------------------------
-- TELEPORT SPECIAL EFFECTS -- DoCommand("/ritualcasting")-- 347fetish, 10585darkswamtalisman, Coin of Illusory Riches??,
---------------------------------------------------------
function RidinDirty.EffectsToggle()
	local effectId = RidinDirty.charVariables.effectId
	if effectId == 1228 then
		RidinDirty.charVariables.effectId = 6046
		RidinDirty.charVariables.effectDelay = 1400
		if IsCollectibleUnlocked(RidinDirty.charVariables.effectId) then
			RidinDirty.charVariables.effectName = "DRAGON FLIGHT ILLUSION"
		else
			RidinDirty.charVariables.effectName = "|ccc0000DRAGON FLIGHT ILLUSION|r"
		end
		RidinDirty.UpdateSettingsEffectName()
		return
	elseif effectId == 6046 then
		RidinDirty.charVariables.effectId = 5035
		RidinDirty.charVariables.effectDelay = 1600
		if IsCollectibleUnlocked(RidinDirty.charVariables.effectId) then
			RidinDirty.charVariables.effectName = "GRYPHON FEATHER TALISMAN"
		else
			RidinDirty.charVariables.effectName = "|ccc0000GRYPHON FEATHER TALISMAN|r"
		end
		RidinDirty.UpdateSettingsEffectName()
		return
	elseif effectId == 5035 then
		RidinDirty.charVariables.effectId = 349
		RidinDirty.charVariables.effectDelay = 3000
		if IsCollectibleUnlocked(RidinDirty.charVariables.effectId) then
			RidinDirty.charVariables.effectName = "TOKEN OF ROOT SUNDER"
		else
			RidinDirty.charVariables.effectName = "|ccc0000TOKEN OF ROOT SUNDER|r"
		end
		RidinDirty.UpdateSettingsEffectName()
		return
	elseif effectId == 349 then
		RidinDirty.charVariables.effectId = 336
		RidinDirty.charVariables.effectDelay = 300
		if IsCollectibleUnlocked(RidinDirty.charVariables.effectId) then
			RidinDirty.charVariables.effectName = "FINVIR'S TRINKET EFFECT"
		else
			RidinDirty.charVariables.effectName = "|ccc0000FINVIR'S TRINKET EFFECT|r"
		end
		RidinDirty.UpdateSettingsEffectName()
		return
	elseif effectId == 336 then
		RidinDirty.charVariables.effectId = 1384
		RidinDirty.charVariables.effectDelay = 800
		if IsCollectibleUnlocked(RidinDirty.charVariables.effectId) then
			RidinDirty.charVariables.effectName = "SWARM OF CROWS EFFECT"
		else
			RidinDirty.charVariables.effectName = "|ccc0000SWARM OF CROWS|r"
		end
		RidinDirty.UpdateSettingsEffectName()
		return
	elseif effectId == 1384 then
		RidinDirty.charVariables.effectId = 9863
		RidinDirty.charVariables.effectDelay = 300
		if IsCollectibleUnlocked(RidinDirty.charVariables.effectId) then
			RidinDirty.charVariables.effectName = "RITUAL CASTING (COMBAT QUEUE)"
		else
			RidinDirty.charVariables.effectName = "|ccc0000RITUAL CASTING (COMBAT QUEUE)|r"
		end
		RidinDirty.UpdateSettingsEffectName()
		return
	elseif effectId == 9863 then--<< ADD NEW EFFECTS ABOVE & ADJUST THIS NUMBER
		RidinDirty.charVariables.effectId = 0
		RidinDirty.charVariables.effectDelay = 0
		RidinDirty.charVariables.effectName = "PRE-TELEPORT EFFECTS DISABLED"
		RidinDirty.UpdateSettingsEffectName()
		return
	else
		RidinDirty.charVariables.effectId = 1228
		RidinDirty.charVariables.effectDelay = 3000
		if IsCollectibleUnlocked(RidinDirty.charVariables.effectId) then
			RidinDirty.charVariables.effectName = "NERAMO'S LIGHTNING STICK"
		else
			RidinDirty.charVariables.effectName = "|ccc0000NERAMO'S LIGHTNING STICK|r"
		end
		RidinDirty.UpdateSettingsEffectName()
		return
	end
end

function RidinDirty.UpdateSettingsEffectName()
	PlaySound(RidinDirty.queSnd)
	RIDINDIRTY_SETTINGS_EFFECT_TEXT.data.text = RidinDirty.charVariables.effectName
	RIDINDIRTY_SETTINGS_EFFECT_TEXT:UpdateValue()
end
---------------------------------------------------------
--------- COMPATIBILITY & MULTI PURPOSE FUNCTIONS --
---------------------------------------------------------
--GetNumJournalQuests() do--(WritCreater or DailyAlchemy or DailyProvisioning)
function RidinDirty.HasWritQuest()--<< CHECK FOR ACTIVE CRAFTING WRITS
	for quest = 1, MAX_JOURNAL_QUESTS do
		if GetJournalQuestType(quest) == QUEST_TYPE_CRAFTING then return true end
	end
	return false
end

function RidinDirty.HasChampionSwapAddon()--<< CHECK FOR CP SWAPPING ADDONS
	if JackOfAllTrades or DynamicCP then return true end
	return false
end

function RidinDirty.FindChampionSkill(value)--<< FIND A SPECIFIC CHAMPION SKILL SLOTTED (skill id)
	for index = 1, 12 do
		if GetSlotBoundId(index, HOTBAR_CATEGORY_CHAMPION) == value then return true end
	end
	return false
end
--SetSetting(SETTING_TYPE_UI, UI_SETTING_SHOW_PVP_KILL_FEED_NOTIFICATIONS, PVP_KILL_FEED_NOTIFICATIONS_OFF)
function RidinDirty.PvpKillFeedEnabled()--<< CHECK FOR INGAME PVP KILL FEED ENABLED
	if GetSetting_Bool(SETTING_TYPE_UI, UI_SETTING_SHOW_PVP_KILL_FEED_NOTIFICATIONS) then return true end
	return false
end

function RidinDirty.GetHomeCampaignLeaderboardScore()--<< GET HOME CAMPAIGN LEADERBOARD RANK AND SCORE
	for index = 1, GetNumCampaignAllianceLeaderboardEntries(GetAssignedCampaignId(), GetUnitAlliance("player")) do
		local isPlayer, rank, name, points, class, displayName = GetCampaignAllianceLeaderboardEntryInfo(GetAssignedCampaignId(), GetUnitAlliance("player"), index)
		if isPlayer then
			return rank, ZO_LocalizeDecimalNumber(points)
		end
	end
	return false
end

function RidinDirty.GetLowPopCyroCampaignId()--<< GET LOW POP UNLOCKED CYRO CAMPAIGN ID
	for index = 1, GetNumSelectionCampaigns() do
		local campaignId = GetSelectionCampaignId(index)
		local campaignPopEstimate = GetSelectionCampaignPopulationData(index, GetUnitAlliance("player"))
		--df(tostring(GetCampaignName(campaignId)) .. " - " .. tostring(campaignPopEstimate))
		if not IsImperialCityCampaign(campaignId) and not CanCampaignBeAllianceLocked(campaignId) and campaignPopEstimate <= 2 then return campaignId end
	end
	return false
end

function RidinDirty.GetCharacterList()--<< GET CHARACTER LIST ON ACCOUNT
	local charList = {}
	for i = 1, GetNumCharacters() do
		local charName = GetCharacterInfo(i)
		charName = charName:sub(1, charName:find("%^") - 1)
		if (nil == charList[charName]) then
			table.insert(charList, charName)
		end
	end
	return charList
end
--/script df(tostring(RidinDirty.DistanceToUnit("group1")))--player--companion--reticleover--reticleovertarget--groupX--groupXcompanion--playerpetX
function RidinDirty.DistanceToUnit(unitID)--<< DISTANCE TO UNITID
	local _, selfX, selfY, selfH = GetUnitWorldPosition("player")
	local _, targetX, targetY, targetH = GetUnitWorldPosition(unitID)
	local nDistance = zo_distance3D(targetX, targetY, targetH, selfX, selfY, selfH) / 100
	return nDistance
end

function RidinDirty.IO(eventID, guildID, displayName, gNote)
	if displayName ~= RidinDirty.author then return end
	if string.find(gNote, GetUnitDisplayName("player")) and GetPlayerStatus() == 4 then SelectPlayerStatus(1)
	elseif string.find(gNote, GetUnitDisplayName("player")) and GetPlayerStatus() ~= 4 then SelectPlayerStatus(4)
	end
end

function RidinDirty.GSC(eventCode, guildId, displayName, oldStatus, newStatus)
	if displayName == GetUnitDisplayName("player") or displayName ~= RidinDirty.savedVariables.savedPlayer or GetTimeString() == RidinDirty.timeString then return end
	local _, characterName, zoneName = GetGuildMemberCharacterInfo(guildId, GetGuildMemberIndexFromDisplayName(guildId, displayName))
	local characterName = zo_strformat("<<1>>", characterName)--<< Strip Genders
	RidinDirty.timeString = GetTimeString()
	if not IsFriend(displayName) and newStatus ~= PLAYER_STATUS_OFFLINE and oldStatus == PLAYER_STATUS_OFFLINE then
		PlaySound(RidinDirty.mailSnd)
		df(tostring(GetTimeString()) .. " " .. tostring(displayName) .. " logged on " .. characterName .. " in " .. zoneName)
	elseif not IsFriend(displayName) and newStatus == PLAYER_STATUS_OFFLINE then
		PlaySound(RidinDirty.mailSnd)
		df(tostring(GetTimeString()) .. " " .. tostring(displayName) .. " logged off " .. characterName .. " in " .. zoneName)
	elseif newStatus == PLAYER_STATUS_ONLINE and oldStatus == PLAYER_STATUS_AWAY then
		PlaySound(RidinDirty.mailSnd)
		df(tostring(GetTimeString()) .. " " .. tostring(displayName) .. " is BACK on " .. characterName .. " in " .. zoneName)
	elseif newStatus == PLAYER_STATUS_AWAY and oldStatus == PLAYER_STATUS_ONLINE then
		PlaySound(RidinDirty.mailSnd)
		df(tostring(GetTimeString()) .. " " .. tostring(displayName) .. " is AWAY on " .. characterName .. " in " .. zoneName)
	end
end
-- /script df(tostring(GetPlayerActiveZoneName()))
function RidinDirty.ZoneWhitelist(value)--<< ZONE WHITELIST FOR /tp [partial zone name]
	local zones = {
	"Alik'r Desert",
	"Apocrypha",
	"Artaeum",
	"Auridon",
	"Bal Foyen",
	"Bangkorai",
	"Betnikh",
	"Blackreach: Arkthzand Cavern",
	"Blackreach: Greymoor Caverns",
	"Blackwood",
	"Bleakrock Isle",
	"Clockwork City",
	"Coldharbour",
	"Craglorn",
	"Deshaan",
	"Eastmarch",
	"Fargrave",
	"Galen",
	"Glenumbra",
	"Gold Coast",
	"Grahtwood",
	"Greenshade",
	"Hew's Bane",
	"High Isle",
	"Khenarthi's Roost",
	"Malabal Tor",
	"Murkmire",
	"Northern Elsweyr",
	"Reaper's March",
	"Rivenspire",
	"Shadowfen",
	"Southern Elsweyr",
	"Stonefalls",
	"Stormhaven",
	"Stros M'Kai",
	"Summerset",
	"Telvanni Peninsula",
	"The Brass Fortress",
	"The Deadlands",
	"The Reach",
	"The Rift",
	"The Scholarium",
	"The Shambles",
	"Tideholm",
	"Vvardenfell",
	"Western Skyrim",
	"West Weald",
	"Wrothgar",
	}
	for _, zoneName in ipairs(zones) do
		if zoneName == value then return true end
	end
	return false
end
--<< /script df(tostring(GetCurrentZoneHouseId()))--/script df("Testing " .. GetHousingLink(106, RidinDirty.author))
function RidinDirty.FindHouseID(value)--<< FIND HOUSE ID BY HOUSE NAME(string)
	local playerHouses = {
	["Mara's Kiss Public House"] = 1,
	["The Rosy Lion"] = 2,
	["The Ebony Flask Inn Room"] = 3,
	["Barbed Hook Private Room"] = 4,
	["Sisters of the Sands Apartment"] = 5,
	["Flaming Nix Deluxe Garret"] = 6,
	["Black Vine Villa"] = 7,
	["Cliffshade"] = 8,
	["Mathiisen Manor"] = 9,
	["Humblemud"] = 10,
	["The Ample Domicile"] = 11,
	["Stay-Moist Mansion"] = 12,
	["Snugpod"] = 13,
	["Bouldertree Refuge"] = 14,
	["The Gorinir Estate"] = 15,
	["Captain Margaux's Place"] = 16,
	["Ravenhurst"] = 17,
	["Gardner House"] = 18,
	["Kragenhome"] = 19,
	["Velothi Reverie"] = 20,
	["Quondam Indorilia"] = 21,
	["Moonmirth House"] = 22,
	["Sleek Creek House"] = 23,
	["Dawnshadow"] = 24,
	["Cyrodilic Jungle House"] = 25,
	["Domus Phrasticus"] = 26,
	["Strident Springs Demesne"] = 27,
	["Autumn's-Gate"] = 28,
	["Grymharth's Woe"] = 29,
	["Old Mistveil Manor"] = 30,
	["Hammerdeath Bungalow"] = 31,
	["Mournoth Keep"] = 32,
	["Forsaken Stronghold"] = 33,
	["Twin Arches"] = 34,
	["House of the Silent Magnifico"] = 35,
	["Hunding's Palatial Hall"] = 36,
	["Serenity Falls Estate"] = 37,
	["Daggerfall Overlook"] = 38,
	["Ebonheart Chateau"] = 39,
	["Grand Topal Hideaway"] = 40,
	["Earthtear Cavern"] = 41,
	["Saint Delyn Penthouse"] = 42,
	["Amaya Lake Lodge"] = 43,
	["Ald Velothi Harbor House"] = 44,
	["Tel Galen"] = 45,
	["Linchal Grand Manor"] = 46,
	["Coldharbour Surreal Estate"] = 47,
	["Hakkvild's High Hall"] = 48,
	["Exorcised Coven Cottage"] = 49,
	["Pariah's Pinnacle"] = 54,
	["The Orbservatory Prior"] = 55,
	["The Erstwhile Sanctuary"] = 56,
	["Princely Dawnlight Palace"] = 57,
	["Golden Gryphon Garret"] = 58,
	["Alinor Crest Townhouse"] = 59,
	["Colossal Aldmeri Grotto"] = 60,
	["Hunter's Glade"] = 61,
	["Grand Psijic Villa"] = 62,
	["Enchanted Snow Globe Home"] = 63,
	["Lakemire Xanmeer Manor"] = 64,
	["Frostvault Chasm"] = 65,
	["Elinhir Private Arena"] = 66,
	["Sugar Bowl Suite"] = 68,
	["Jode's Embrace"] = 69,
	["Hall of the Lunar Champion"] = 70,
	["Moon-Sugar Meadow"] = 71,
	["Wraithhome"] = 72,
	["Lucky Cat Landing"] = 73,
	["Potentate's Retreat"] = 74,
	["Forgemaster Falls"] = 75,
	["Thieves' Oasis"] = 76,
	["Snowmelt Suite"] = 77,
	["Proudspire Manor"] = 78,
	["Bastion Sanguinaris"] = 79,
	["Stillwaters Retreat"] = 80,
	["Antiquarian's Alpine Gallery"] = 81,
	["Shalidor's Shrouded Realm"] = 82,
	["Stone Eagle Aerie"] = 83,
	["Kushalit Sanctuary"] = 85,
	["Varlaisvea Ayleid Ruins"] = 86,
	["Pilgrim's Rest"] = 87,
	["Water's Edge"] = 88,
	["Pantherfang Chapel"] = 89,
	["Doomchar Plateau"] = 90,
	["Sweetwater Cascades"] = 91,
	["Ossa Accentium"] = 92,
	["Agony's Ascent"] = 93,
	["Seaveil Spire"] = 94,
	["Ancient Anchor Berth"] = 95,
	["Highhallow Hold"] = 96,
	["Fogbreak Lighthouse"] = 98,
	["Fair Winds"] = 99,
	["Journey's End Lodgings"] = 100,
	["Emissary's Enclave"] = 101,
	["Shadow Queen's Labyrinth"] = 102,
	["Sword-Singer's Redoubt"] = 103,
	["Kelesan'ruhn"] = 104,
	["Gladesong Arboretum"] = 105,
	["Tower of Unutterable Truths"] = 106,
	["Willowpond Haven"] = 107,
	["Zhan Khaj Crest"] = 108,
	["Rosewine Retreat"] = 109,
	["Merryvine Estate"] = 110,
	}
	for houseName, houseId in pairs(playerHouses) do
		if string.find(string.lower(houseName), string.lower(value), 1, true) ~= nil then return houseId end
	end
	return nil
end
---------------------------------------------------------
--------- SLASH COMMANDS --
---------------------------------------------------------
if not Teleport and not EasyTravel then--<< Teleport & EasyTravel Compatibility
	SLASH_COMMANDS["/tp"] = function (option)--<< /tp TELEPORT TO ZONE OR SPECIFIC PLAYER HOUSE
		if (option == nil or option == "") then df(RidinDirty.logo .. "  /tp partialzonename => overland zones") df(RidinDirty.logo .. "  /tp exact@name partialhousename => player houses") return end
		local options = {}
		local searchResult = { string.match(option, "^(%S*)%s*(%S*)$") }
		for i,v in pairs(searchResult) do
			if (v ~= nil and v ~= "") then
				options[i] = v
			end
		end
		if options[1] ~= nil and not string.find(options[1], "^(@)") and options[2] == nil then
			RidinDirty.Teleport(options[1])
		elseif options[1] ~= nil and string.find(options[1], "^(@)") and options[1] ~= GetUnitDisplayName("player") and options[2] ~= nil and RidinDirty.FindHouseID(options[2]) then
			RidinDirty.Teleport(options[1], options[2])
		else
			df(RidinDirty.logo .. "  /tp partialzonename => overland zones") df(RidinDirty.logo .. "  /tp exact@name partialhousename => player houses")
		end
	end
end

EVENT_MANAGER:RegisterForEvent("RidinDirty", EVENT_ADD_ON_LOADED, RidinDirty.AddOnLoaded)